/*
 * emptymodel_1_sm_master.c
 * 
 * Real-Time Workshop code generation for Simulink model "emptymodel_1_sm_master.mdl".
 *
 * Model Version              : 1.735
 * Real-Time Workshop version : 6.3  (R14SP3)  26-Jul-2005
 * C source code generated on : Wed Sep 19 17:35:06 2007
 */

#include <math.h>
#include "emptymodel_1_sm_master.h"
#include "emptymodel_1_sm_master_private.h"
#include "simstruc.h"
#include "fixedpoint.h"

/* Block signals (auto storage) */
BlockIO rtB;

/* Block states (auto storage) */
D_Work rtDWork;

/* Parent Simstruct */
static SimStruct model_S;
SimStruct *const rtS = &model_S;

/* Initial conditions for root system: '<Root>' */
void MdlInitialize(void)
{

  /* user code (Initialize function Body) */
  /* System: <Root> */
  /* Opal-RT Technologies */
  opalSizeDwork = sizeof(rtDWork);
  if(ssGetNumBlockIO(rtS) != 0)
  opalSizeBlockIO = sizeof(rtB);
  else
  opalSizeBlockIO = 0;
  if(ssGetNumBlockParams(rtS) != 0)
  opalSizeRTP = sizeof(rtP);
  else
  opalSizeRTP = 0;

  /* Level2 S-Function Block: <S6>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S7>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 1);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S3>/S-Function (OP_SEND) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 2);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S8>/S-Function (RECV_Param) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 3);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S7>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }
}

/* Start for root system: '<Root>' */
void MdlStart(void)
{
  MdlInitialize();
}

/* Outputs for root system: '<Root>' */
void MdlOutputs(int_T tid)
{
  /* local block i/o variables*/
  real_T rtb_Sum1;
  real_T rtb_Sum1_e;
  real_T rtb_r64_temp76;
  real_T rtb_r64_temp77;
  real_T rtb_r64_temp78;
  real_T rtb_r64_temp79;
  real_T rtb_r64_temp80;
  real_T rtb_r64_temp81;
  real_T rtb_r64_temp82;
  real_T rtb_r64_temp83;
  real_T rtb_r64_temp84;
  real_T rtb_r64_temp85;
  real_T rtb_r64_temp86;
  real_T rtb_r64_temp87;
  real_T rtb_r64_temp88;
  real_T rtb_r64_temp89;
  real_T rtb_r64_temp90;
  real_T rtb_r64_temp91;
  real_T rtb_r64_temp92;

  /* tid is required for a uniform function interface. This system
   * is single rate, and in this case, tid is not accessed. */
  UNUSED_PARAMETER(tid);

  /* Level2 S-Function Block: <S6>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);

    sfcnOutputs(rts, tid);
  }

  /* Gain: '<S6>/-12' */
  rtB.u2 = rtB.SFunction[0] * rtP.u2_Gain;

  /* Gain: '<S6>/-2' */
  rtB.u = rtB.SFunction[1] * rtP.u_Gain;

  /* Gain: '<S6>/-5' */
  rtB.u_n = rtB.SFunction[4] * rtP.u_Gain_p;

  /* Gain: '<S6>/-6' */
  rtB.u_nz = rtB.SFunction[5] * rtP.u_Gain_k;

  /* Gain: '<S6>/-11' */
  rtB.u1 = rtB.SFunction[6] * rtP.u1_Gain;

  /* Gain: '<S6>/-10' */
  rtB.u0 = rtB.SFunction[7] * rtP.u0_Gain;

  /* Level2 S-Function Block: <S7>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 1);

    sfcnOutputs(rts, tid);
  }

  /* Sum: '<S10>/Sum1' incorporates:
   *  Sum: '<S10>/Sum2'
   *  Product: '<S10>/Product'
   *  Gain: '<S10>/Unit 2 deg'
   *  Constant: '<S10>/Range [V]'
   *  Constant: '<S10>/offset'
   *  Constant: '<S10>/min [V] '
   */
  rtb_Sum1 = (rtB.OpDM6210AnalogIn[8] - rtP.minV_Value) / rtP.RangeV_Value *
    rtP.Unit2deg_Gain - rtP.offset_Value;

  /* Gain: '<S19>/Gain' incorporates:
   *  Signum: '<S19>/Sign'
   */
  rtb_r64_temp84 = rt_SGN(rtb_Sum1) * rtP.Gain_Gain;

  /* Sum: '<S19>/Sum1' */
  rtb_r64_temp78 = rtb_Sum1 + rtb_r64_temp84;

  /* Math: '<S19>/Math Function' incorporates:
   *  Constant: '<S19>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value));
      u2Fix = ((rtP.Constant_Value < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value == 0.0) {
      rtb_r64_temp78 = rtNaN;
    } else if ( rtP.Constant_Value == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp78 / rtP.Constant_Value;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp78 = (rtb_r64_temp78 - uDivFix * rtP.Constant_Value);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp78 / rtP.Constant_Value;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp78 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp78 = (uDiv - uDivFix) * rtP.Constant_Value;
      }
    }
  }

  /* Sum: '<S19>/Sum' */
  rtB.Sum = rtb_r64_temp78 - rtb_r64_temp84;

  /* Sum: '<S11>/Sum1' incorporates:
   *  Sum: '<S11>/Sum2'
   *  Product: '<S11>/Product'
   *  Gain: '<S11>/Unit 2 deg'
   *  Constant: '<S11>/offset'
   *  Constant: '<S11>/min [V] '
   *  Constant: '<S11>/Range [V]'
   */
  rtb_Sum1_e = (rtB.OpDM6210AnalogIn[9] - rtP.minV_Value_o) / rtP.RangeV_Value_d
    * rtP.Unit2deg_Gain_m - rtP.offset_Value_o;

  /* Gain: '<S21>/Gain' incorporates:
   *  Signum: '<S21>/Sign'
   */
  rtb_r64_temp85 = rt_SGN(rtb_Sum1_e) * rtP.Gain_Gain_n;

  /* Sum: '<S21>/Sum1' */
  rtb_r64_temp88 = rtb_Sum1_e + rtb_r64_temp85;

  /* Math: '<S21>/Math Function' incorporates:
   *  Constant: '<S21>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_d));
      u2Fix = ((rtP.Constant_Value_d < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_d == 0.0) {
      rtb_r64_temp88 = rtNaN;
    } else if ( rtP.Constant_Value_d == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp88 / rtP.Constant_Value_d;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp88 = (rtb_r64_temp88 - uDivFix * rtP.Constant_Value_d);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp88 / rtP.Constant_Value_d;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp88 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp88 = (uDiv - uDivFix) * rtP.Constant_Value_d;
      }
    }
  }

  /* Sum: '<S21>/Sum' */
  rtB.Sum_d = rtb_r64_temp88 - rtb_r64_temp85;

  /* Sum: '<S12>/Sum1' incorporates:
   *  Sum: '<S12>/Sum2'
   *  Product: '<S12>/Product'
   *  Gain: '<S12>/Unit 2 deg'
   *  Constant: '<S12>/offset'
   *  Constant: '<S12>/min [V] '
   *  Constant: '<S12>/Range [V]'
   */
  rtb_r64_temp78 = (rtB.OpDM6210AnalogIn[10] - rtP.minV_Value_e) /
    rtP.RangeV_Value_o * rtP.Unit2deg_Gain_p - rtP.offset_Value_j;

  /* Gain: '<S23>/Gain' incorporates:
   *  Signum: '<S23>/Sign'
   */
  rtb_r64_temp84 = rt_SGN(rtb_r64_temp78) * rtP.Gain_Gain_g;

  /* Sum: '<S23>/Sum1' */
  rtb_r64_temp89 = rtb_r64_temp78 + rtb_r64_temp84;

  /* Math: '<S23>/Math Function' incorporates:
   *  Constant: '<S23>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_i));
      u2Fix = ((rtP.Constant_Value_i < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_i == 0.0) {
      rtb_r64_temp89 = rtNaN;
    } else if ( rtP.Constant_Value_i == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp89 / rtP.Constant_Value_i;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp89 = (rtb_r64_temp89 - uDivFix * rtP.Constant_Value_i);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp89 / rtP.Constant_Value_i;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp89 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp89 = (uDiv - uDivFix) * rtP.Constant_Value_i;
      }
    }
  }

  /* Sum: '<S23>/Sum' */
  rtB.Sum_m = rtb_r64_temp89 - rtb_r64_temp84;

  /* Sum: '<S13>/Sum1' incorporates:
   *  Sum: '<S13>/Sum2'
   *  Product: '<S13>/Product'
   *  Gain: '<S13>/Unit 2 deg'
   *  Constant: '<S13>/Range [V]'
   *  Constant: '<S13>/min [V] '
   *  Constant: '<S13>/offset'
   */
  rtb_r64_temp88 = (rtB.OpDM6210AnalogIn[11] - rtP.minV_Value_k) /
    rtP.RangeV_Value_g * rtP.Unit2deg_Gain_e - rtP.offset_Value_h;

  /* Gain: '<S25>/Gain' incorporates:
   *  Signum: '<S25>/Sign'
   */
  rtb_r64_temp85 = rt_SGN(rtb_r64_temp88) * rtP.Gain_Gain_o;

  /* Sum: '<S25>/Sum1' */
  rtb_r64_temp80 = rtb_r64_temp88 + rtb_r64_temp85;

  /* Math: '<S25>/Math Function' incorporates:
   *  Constant: '<S25>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_c));
      u2Fix = ((rtP.Constant_Value_c < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_c == 0.0) {
      rtb_r64_temp80 = rtNaN;
    } else if ( rtP.Constant_Value_c == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp80 / rtP.Constant_Value_c;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp80 = (rtb_r64_temp80 - uDivFix * rtP.Constant_Value_c);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp80 / rtP.Constant_Value_c;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp80 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp80 = (uDiv - uDivFix) * rtP.Constant_Value_c;
      }
    }
  }

  /* Sum: '<S25>/Sum' */
  rtB.Sum_o = rtb_r64_temp80 - rtb_r64_temp85;

  /* Sum: '<S14>/Sum1' incorporates:
   *  Sum: '<S14>/Sum2'
   *  Product: '<S14>/Product'
   *  Gain: '<S14>/Unit 2 deg'
   *  Constant: '<S14>/Range [V]'
   *  Constant: '<S14>/min [V] '
   *  Constant: '<S14>/offset'
   */
  rtb_r64_temp89 = (rtB.OpDM6210AnalogIn[12] - rtP.minV_Value_f) /
    rtP.RangeV_Value_p * rtP.Unit2deg_Gain_pq - rtP.offset_Value_m;

  /* Gain: '<S27>/Gain' incorporates:
   *  Signum: '<S27>/Sign'
   */
  rtb_r64_temp84 = rt_SGN(rtb_r64_temp89) * rtP.Gain_Gain_i;

  /* Sum: '<S27>/Sum1' */
  rtb_r64_temp81 = rtb_r64_temp89 + rtb_r64_temp84;

  /* Math: '<S27>/Math Function' incorporates:
   *  Constant: '<S27>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_e));
      u2Fix = ((rtP.Constant_Value_e < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_e == 0.0) {
      rtb_r64_temp81 = rtNaN;
    } else if ( rtP.Constant_Value_e == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp81 / rtP.Constant_Value_e;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp81 = (rtb_r64_temp81 - uDivFix * rtP.Constant_Value_e);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp81 / rtP.Constant_Value_e;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp81 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp81 = (uDiv - uDivFix) * rtP.Constant_Value_e;
      }
    }
  }

  /* Sum: '<S27>/Sum' */
  rtB.Sum_df = rtb_r64_temp81 - rtb_r64_temp84;

  /* Sum: '<S15>/Sum1' incorporates:
   *  Sum: '<S15>/Sum2'
   *  Product: '<S15>/Product'
   *  Gain: '<S15>/Unit 2 deg'
   *  Constant: '<S15>/offset'
   *  Constant: '<S15>/min [V] '
   *  Constant: '<S15>/Range [V]'
   */
  rtb_r64_temp80 = (rtB.OpDM6210AnalogIn[13] - rtP.minV_Value_m) /
    rtP.RangeV_Value_e * rtP.Unit2deg_Gain_b - rtP.offset_Value_g;

  /* Gain: '<S29>/Gain' incorporates:
   *  Signum: '<S29>/Sign'
   */
  rtb_r64_temp85 = rt_SGN(rtb_r64_temp80) * rtP.Gain_Gain_a;

  /* Sum: '<S29>/Sum1' */
  rtb_r64_temp79 = rtb_r64_temp80 + rtb_r64_temp85;

  /* Math: '<S29>/Math Function' incorporates:
   *  Constant: '<S29>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_en));
      u2Fix = ((rtP.Constant_Value_en < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_en == 0.0) {
      rtb_r64_temp79 = rtNaN;
    } else if ( rtP.Constant_Value_en == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp79 / rtP.Constant_Value_en;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp79 = (rtb_r64_temp79 - uDivFix * rtP.Constant_Value_en);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp79 / rtP.Constant_Value_en;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp79 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp79 = (uDiv - uDivFix) * rtP.Constant_Value_en;
      }
    }
  }

  /* Sum: '<S29>/Sum' */
  rtB.Sum_ox = rtb_r64_temp79 - rtb_r64_temp85;

  /* Sum: '<S16>/Sum1' incorporates:
   *  Sum: '<S16>/Sum2'
   *  Product: '<S16>/Product'
   *  Gain: '<S16>/Unit 2 deg'
   *  Constant: '<S16>/offset'
   *  Constant: '<S16>/min [V] '
   *  Constant: '<S16>/Range [V]'
   */
  rtb_r64_temp81 = (rtB.OpDM6210AnalogIn[14] - rtP.minV_Value_fb) /
    rtP.RangeV_Value_l * rtP.Unit2deg_Gain_ef - rtP.offset_Value_e;

  /* Gain: '<S31>/Gain' incorporates:
   *  Signum: '<S31>/Sign'
   */
  rtb_r64_temp84 = rt_SGN(rtb_r64_temp81) * rtP.Gain_Gain_nf;

  /* Sum: '<S31>/Sum1' */
  rtb_r64_temp90 = rtb_r64_temp81 + rtb_r64_temp84;

  /* Math: '<S31>/Math Function' incorporates:
   *  Constant: '<S31>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_k));
      u2Fix = ((rtP.Constant_Value_k < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_k == 0.0) {
      rtb_r64_temp90 = rtNaN;
    } else if ( rtP.Constant_Value_k == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp90 / rtP.Constant_Value_k;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp90 = (rtb_r64_temp90 - uDivFix * rtP.Constant_Value_k);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp90 / rtP.Constant_Value_k;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp90 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp90 = (uDiv - uDivFix) * rtP.Constant_Value_k;
      }
    }
  }

  /* Sum: '<S31>/Sum' */
  rtB.Sum_c = rtb_r64_temp90 - rtb_r64_temp84;

  /* Sum: '<S17>/Sum1' incorporates:
   *  Sum: '<S17>/Sum2'
   *  Product: '<S17>/Product'
   *  Gain: '<S17>/Unit 2 deg'
   *  Constant: '<S17>/offset'
   *  Constant: '<S17>/min [V] '
   *  Constant: '<S17>/Range [V]'
   */
  rtb_r64_temp79 = (rtB.OpDM6210AnalogIn[15] - rtP.minV_Value_h) /
    rtP.RangeV_Value_a * rtP.Unit2deg_Gain_g - rtP.offset_Value_i;

  /* Gain: '<S33>/Gain' incorporates:
   *  Signum: '<S33>/Sign'
   */
  rtb_r64_temp85 = rt_SGN(rtb_r64_temp79) * rtP.Gain_Gain_ab;

  /* Sum: '<S33>/Sum1' */
  rtb_r64_temp91 = rtb_r64_temp79 + rtb_r64_temp85;

  /* Math: '<S33>/Math Function' incorporates:
   *  Constant: '<S33>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_a));
      u2Fix = ((rtP.Constant_Value_a < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_a == 0.0) {
      rtb_r64_temp91 = rtNaN;
    } else if ( rtP.Constant_Value_a == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp91 / rtP.Constant_Value_a;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp91 = (rtb_r64_temp91 - uDivFix * rtP.Constant_Value_a);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp91 / rtP.Constant_Value_a;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp91 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp91 = (uDiv - uDivFix) * rtP.Constant_Value_a;
      }
    }
  }

  /* Sum: '<S33>/Sum' */
  rtB.Sum_da = rtb_r64_temp91 - rtb_r64_temp85;

  /* Level2 S-Function Block: <S3>/S-Function (OP_SEND) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 2);

    sfcnOutputs(rts, tid);
  }

  /* Level2 S-Function Block: <S8>/S-Function (RECV_Param) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 3);

    sfcnOutputs(rts, tid);
  }

  /* SignalConversion: '<S6>/TmpHiddenBufferAtS-FunctionInport1' incorporates:
   *  Saturate: '<S9>/Saturation2'
   *  Gain: '<S6>/-1'
   *  Saturate: '<S9>/Saturation5'
   *  Gain: '<S6>/-3'
   *  Saturate: '<S9>/Saturation6'
   *  Gain: '<S6>/-4'
   *  Saturate: '<S9>/Saturation1'
   *  Gain: '<S6>/-7'
   *  Saturate: '<S9>/Saturation7'
   *  Gain: '<S6>/-8'
   *  Saturate: '<S9>/Saturation8'
   *  Gain: '<S6>/-9'
   *  Saturate: '<S9>/Saturation3'
   *  Saturate: '<S9>/Saturation4'
   */
  rtB.TmpHiddenBufferAtSFunctionInpo[0] = rt_SATURATE(rtB.SFunction_i[8],
   rtP.Saturation1_LowerSat, rtP.Saturation1_UpperSat) * rtP.u_Gain_d;
  rtB.TmpHiddenBufferAtSFunctionInpo[1] = rt_SATURATE(rtB.SFunction_i[9],
   rtP.Saturation2_LowerSat, rtP.Saturation2_UpperSat) * rtP.u_Gain_a;
  rtB.TmpHiddenBufferAtSFunctionInpo[2] = rt_SATURATE(rtB.SFunction_i[10],
   rtP.Saturation3_LowerSat, rtP.Saturation3_UpperSat);
  rtB.TmpHiddenBufferAtSFunctionInpo[3] = rt_SATURATE(rtB.SFunction_i[11],
   rtP.Saturation4_LowerSat, rtP.Saturation4_UpperSat);
  rtB.TmpHiddenBufferAtSFunctionInpo[4] = rt_SATURATE(rtB.SFunction_i[12],
   rtP.Saturation5_LowerSat, rtP.Saturation5_UpperSat) * rtP.u_Gain_av;
  rtB.TmpHiddenBufferAtSFunctionInpo[5] = rt_SATURATE(rtB.SFunction_i[13],
   rtP.Saturation6_LowerSat, rtP.Saturation6_UpperSat) * rtP.u_Gain_ag;
  rtB.TmpHiddenBufferAtSFunctionInpo[6] = rt_SATURATE(rtB.SFunction_i[14],
   rtP.Saturation7_LowerSat, rtP.Saturation7_UpperSat) * rtP.u_Gain_pu;
  rtB.TmpHiddenBufferAtSFunctionInpo[7] = rt_SATURATE(rtB.SFunction_i[15],
   rtP.Saturation8_LowerSat, rtP.Saturation8_UpperSat) * rtP.u_Gain_i;

  /* Sum: '<S10>/Sum' */
  rtb_r64_temp83 = rtB.SFunction_i[0] - rtb_Sum1;

  /* Gain: '<S18>/Gain' incorporates:
   *  Signum: '<S18>/Sign'
   */
  rtb_r64_temp77 = rt_SGN(rtb_r64_temp83) * rtP.Gain_Gain_h;

  /* Sum: '<S18>/Sum1' */
  rtb_r64_temp92 = rtb_r64_temp83 + rtb_r64_temp77;

  /* Math: '<S18>/Math Function' incorporates:
   *  Constant: '<S18>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_b));
      u2Fix = ((rtP.Constant_Value_b < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_b == 0.0) {
      rtb_r64_temp92 = rtNaN;
    } else if ( rtP.Constant_Value_b == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp92 / rtP.Constant_Value_b;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp92 = (rtb_r64_temp92 - uDivFix * rtP.Constant_Value_b);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp92 / rtP.Constant_Value_b;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp92 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp92 = (uDiv - uDivFix) * rtP.Constant_Value_b;
      }
    }
  }

  /* Gain: '<S10>/Step//deg' incorporates:
   *  Sum: '<S18>/Sum'
   */
  rtb_r64_temp83 = (rtb_r64_temp92 - rtb_r64_temp77) * rtP.Stepdeg_Gain;

  /* Saturate: '<S10>/Saturation' */
  rtb_r64_temp76 = rt_SATURATE(rtb_r64_temp83, rtP.Saturation_LowerSat,
   rtP.Saturation_UpperSat);

  /* Sum: '<S11>/Sum3' */
  rtb_r64_temp83 = rtB.SFunction_i[1] - rtb_Sum1_e;

  /* Gain: '<S20>/Gain' incorporates:
   *  Signum: '<S20>/Sign'
   */
  rtb_r64_temp86 = rt_SGN(rtb_r64_temp83) * rtP.Gain_Gain_f;

  /* Sum: '<S20>/Sum1' */
  rtb_r64_temp87 = rtb_r64_temp83 + rtb_r64_temp86;

  /* Math: '<S20>/Math Function' incorporates:
   *  Constant: '<S20>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_l));
      u2Fix = ((rtP.Constant_Value_l < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_l == 0.0) {
      rtb_r64_temp87 = rtNaN;
    } else if ( rtP.Constant_Value_l == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp87 / rtP.Constant_Value_l;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp87 = (rtb_r64_temp87 - uDivFix * rtP.Constant_Value_l);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp87 / rtP.Constant_Value_l;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp87 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp87 = (uDiv - uDivFix) * rtP.Constant_Value_l;
      }
    }
  }

  /* Gain: '<S11>/Step//deg1' incorporates:
   *  Sum: '<S20>/Sum'
   */
  rtb_r64_temp92 = (rtb_r64_temp87 - rtb_r64_temp86) * rtP.Stepdeg1_Gain;

  /* Saturate: '<S11>/Saturation' */
  rtb_r64_temp77 = rt_SATURATE(rtb_r64_temp92, rtP.Saturation_LowerSat_o,
   rtP.Saturation_UpperSat_a);

  /* Sum: '<S12>/Sum' */
  rtb_r64_temp92 = rtB.SFunction_i[2] - rtb_r64_temp78;

  /* Gain: '<S22>/Gain' incorporates:
   *  Signum: '<S22>/Sign'
   */
  rtb_r64_temp82 = rt_SGN(rtb_r64_temp92) * rtP.Gain_Gain_m;

  /* Sum: '<S22>/Sum1' */
  rtb_r64_temp91 = rtb_r64_temp92 + rtb_r64_temp82;

  /* Math: '<S22>/Math Function' incorporates:
   *  Constant: '<S22>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_f));
      u2Fix = ((rtP.Constant_Value_f < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_f == 0.0) {
      rtb_r64_temp91 = rtNaN;
    } else if ( rtP.Constant_Value_f == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp91 / rtP.Constant_Value_f;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp91 = (rtb_r64_temp91 - uDivFix * rtP.Constant_Value_f);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp91 / rtP.Constant_Value_f;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp91 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp91 = (uDiv - uDivFix) * rtP.Constant_Value_f;
      }
    }
  }

  /* Gain: '<S12>/Step//deg' incorporates:
   *  Sum: '<S22>/Sum'
   */
  rtb_r64_temp92 = (rtb_r64_temp91 - rtb_r64_temp82) * rtP.Stepdeg_Gain_f;

  /* Saturate: '<S12>/Saturation' */
  rtb_r64_temp83 = rt_SATURATE(rtb_r64_temp92, rtP.Saturation_LowerSat_e,
   rtP.Saturation_UpperSat_j);

  /* Sum: '<S13>/Sum3' */
  rtb_r64_temp92 = rtB.SFunction_i[3] - rtb_r64_temp88;

  /* Gain: '<S24>/Gain' incorporates:
   *  Signum: '<S24>/Sign'
   */
  rtb_r64_temp87 = rt_SGN(rtb_r64_temp92) * rtP.Gain_Gain_gf;

  /* Sum: '<S24>/Sum1' */
  rtb_r64_temp90 = rtb_r64_temp92 + rtb_r64_temp87;

  /* Math: '<S24>/Math Function' incorporates:
   *  Constant: '<S24>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_m));
      u2Fix = ((rtP.Constant_Value_m < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_m == 0.0) {
      rtb_r64_temp90 = rtNaN;
    } else if ( rtP.Constant_Value_m == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp90 / rtP.Constant_Value_m;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp90 = (rtb_r64_temp90 - uDivFix * rtP.Constant_Value_m);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp90 / rtP.Constant_Value_m;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp90 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp90 = (uDiv - uDivFix) * rtP.Constant_Value_m;
      }
    }
  }

  /* Gain: '<S13>/Step//deg' incorporates:
   *  Sum: '<S24>/Sum'
   */
  rtb_r64_temp92 = (rtb_r64_temp90 - rtb_r64_temp87) * rtP.Stepdeg_Gain_i;

  /* Saturate: '<S13>/Saturation' */
  rtb_r64_temp82 = rt_SATURATE(rtb_r64_temp92, rtP.Saturation_LowerSat_n,
   rtP.Saturation_UpperSat_i);

  /* Sum: '<S14>/Sum' */
  rtb_r64_temp92 = rtB.SFunction_i[4] - rtb_r64_temp89;

  /* Gain: '<S26>/Gain' incorporates:
   *  Signum: '<S26>/Sign'
   */
  rtb_r64_temp91 = rt_SGN(rtb_r64_temp92) * rtP.Gain_Gain_n4;

  /* Sum: '<S26>/Sum1' */
  rtb_r64_temp88 = rtb_r64_temp92 + rtb_r64_temp91;

  /* Math: '<S26>/Math Function' incorporates:
   *  Constant: '<S26>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_lh));
      u2Fix = ((rtP.Constant_Value_lh < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_lh == 0.0) {
      rtb_r64_temp88 = rtNaN;
    } else if ( rtP.Constant_Value_lh == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp88 / rtP.Constant_Value_lh;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp88 = (rtb_r64_temp88 - uDivFix * rtP.Constant_Value_lh);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp88 / rtP.Constant_Value_lh;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp88 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp88 = (uDiv - uDivFix) * rtP.Constant_Value_lh;
      }
    }
  }

  /* Gain: '<S14>/Step//deg' incorporates:
   *  Sum: '<S26>/Sum'
   */
  rtb_r64_temp92 = (rtb_r64_temp88 - rtb_r64_temp91) * rtP.Stepdeg_Gain_e;

  /* Saturate: '<S14>/Saturation' */
  rtb_r64_temp86 = rt_SATURATE(rtb_r64_temp92, rtP.Saturation_LowerSat_nw,
   rtP.Saturation_UpperSat_g);

  /* Sum: '<S15>/Sum3' */
  rtb_r64_temp92 = rtB.SFunction_i[5] - rtb_r64_temp80;

  /* Gain: '<S28>/Gain' incorporates:
   *  Signum: '<S28>/Sign'
   */
  rtb_r64_temp90 = rt_SGN(rtb_r64_temp92) * rtP.Gain_Gain_ae;

  /* Sum: '<S28>/Sum1' */
  rtb_r64_temp89 = rtb_r64_temp92 + rtb_r64_temp90;

  /* Math: '<S28>/Math Function' incorporates:
   *  Constant: '<S28>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_a1));
      u2Fix = ((rtP.Constant_Value_a1 < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_a1 == 0.0) {
      rtb_r64_temp89 = rtNaN;
    } else if ( rtP.Constant_Value_a1 == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp89 / rtP.Constant_Value_a1;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp89 = (rtb_r64_temp89 - uDivFix * rtP.Constant_Value_a1);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp89 / rtP.Constant_Value_a1;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp89 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp89 = (uDiv - uDivFix) * rtP.Constant_Value_a1;
      }
    }
  }

  /* Gain: '<S15>/Step//deg' incorporates:
   *  Sum: '<S28>/Sum'
   */
  rtb_r64_temp92 = (rtb_r64_temp89 - rtb_r64_temp90) * rtP.Stepdeg_Gain_d;

  /* Saturate: '<S15>/Saturation' */
  rtb_r64_temp87 = rt_SATURATE(rtb_r64_temp92, rtP.Saturation_LowerSat_p,
   rtP.Saturation_UpperSat_m);

  /* Sum: '<S16>/Sum' */
  rtb_r64_temp92 = rtB.SFunction_i[6] - rtb_r64_temp81;

  /* Gain: '<S30>/Gain' incorporates:
   *  Signum: '<S30>/Sign'
   */
  rtb_r64_temp80 = rt_SGN(rtb_r64_temp92) * rtP.Gain_Gain_an;

  /* Sum: '<S30>/Sum1' */
  rtb_r64_temp88 = rtb_r64_temp92 + rtb_r64_temp80;

  /* Math: '<S30>/Math Function' incorporates:
   *  Constant: '<S30>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_iv));
      u2Fix = ((rtP.Constant_Value_iv < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_iv == 0.0) {
      rtb_r64_temp88 = rtNaN;
    } else if ( rtP.Constant_Value_iv == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp88 / rtP.Constant_Value_iv;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp88 = (rtb_r64_temp88 - uDivFix * rtP.Constant_Value_iv);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp88 / rtP.Constant_Value_iv;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp88 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp88 = (uDiv - uDivFix) * rtP.Constant_Value_iv;
      }
    }
  }

  /* Gain: '<S16>/Step//deg' incorporates:
   *  Sum: '<S30>/Sum'
   */
  rtb_r64_temp92 = (rtb_r64_temp88 - rtb_r64_temp80) * rtP.Stepdeg_Gain_j;

  /* Saturate: '<S16>/Saturation' */
  rtb_r64_temp91 = rt_SATURATE(rtb_r64_temp92, rtP.Saturation_LowerSat_i,
   rtP.Saturation_UpperSat_p);

  /* Sum: '<S17>/Sum3' */
  rtb_r64_temp92 = rtB.SFunction_i[7] - rtb_r64_temp79;

  /* Gain: '<S32>/Gain' incorporates:
   *  Signum: '<S32>/Sign'
   */
  rtb_r64_temp81 = rt_SGN(rtb_r64_temp92) * rtP.Gain_Gain_hh;

  /* Sum: '<S32>/Sum1' */
  rtb_r64_temp89 = rtb_r64_temp92 + rtb_r64_temp81;

  /* Math: '<S32>/Math Function' incorporates:
   *  Constant: '<S32>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_f4));
      u2Fix = ((rtP.Constant_Value_f4 < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_f4 == 0.0) {
      rtb_r64_temp89 = rtNaN;
    } else if ( rtP.Constant_Value_f4 == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp89 / rtP.Constant_Value_f4;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp89 = (rtb_r64_temp89 - uDivFix * rtP.Constant_Value_f4);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp89 / rtP.Constant_Value_f4;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp89 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp89 = (uDiv - uDivFix) * rtP.Constant_Value_f4;
      }
    }
  }

  /* Gain: '<S17>/Step//deg' incorporates:
   *  Sum: '<S32>/Sum'
   */
  rtb_r64_temp92 = (rtb_r64_temp89 - rtb_r64_temp81) * rtP.Stepdeg_Gain_c;

  /* Saturate: '<S17>/Saturation' */
  rtb_r64_temp90 = rt_SATURATE(rtb_r64_temp92, rtP.Saturation_LowerSat_b,
   rtP.Saturation_UpperSat_n);

  /* Level2 S-Function Block: <S7>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);

    sfcnOutputs(rts, tid);
  }

  /* SignalConversion: '<S7>/TmpHiddenBufferAtThruster Orientation motorControllInport1' incorporates:
   *  Constant: '<S7>/dummy (this axe is not used)'
   */
  rtB.TmpHiddenBufferAtThrusterOrien[0] = rtb_r64_temp76;
  rtB.TmpHiddenBufferAtThrusterOrien[1] = rtb_r64_temp77;
  rtB.TmpHiddenBufferAtThrusterOrien[2] = rtb_r64_temp83;
  rtB.TmpHiddenBufferAtThrusterOrien[3] = rtb_r64_temp91;
  rtB.TmpHiddenBufferAtThrusterOrien[4] = rtb_r64_temp90;
  rtB.TmpHiddenBufferAtThrusterOrien[5] = rtb_r64_temp82;
  rtB.TmpHiddenBufferAtThrusterOrien[6] = rtb_r64_temp86;
  rtB.TmpHiddenBufferAtThrusterOrien[7] = rtb_r64_temp87;
  rtB.TmpHiddenBufferAtThrusterOrien[8] = rtP.dummythisaxeisnotused;
}

/* Update for root system: '<Root>' */
void MdlUpdate(int_T tid)
{

  /* tid is required for a uniform function interface. This system
   * is single rate, and in this case, tid is not accessed. */
  UNUSED_PARAMETER(tid);

  /* Level2 S-Function Block: <S6>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);

    sfcnUpdate(rts, tid);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S7>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);

    sfcnUpdate(rts, tid);
    if(ssGetErrorStatus(rts) != NULL) return;
  }
}

/* Terminate for root system: '<Root>' */
void MdlTerminate(void)
{

  /* Level2 S-Function Block: <S6>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S7>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 1);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S3>/S-Function (OP_SEND) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 2);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S8>/S-Function (RECV_Param) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 3);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S7>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);
    sfcnTerminate(rts);
  }
}

/* Function to initialize sizes */
void MdlInitializeSizes(void)
{
  ssSetNumContStates(rtS, 0);           /* Number of continuous states */
  ssSetNumY(rtS, 0);                    /* Number of model outputs */
  ssSetNumU(rtS, 0);                    /* Number of model inputs */
  ssSetDirectFeedThrough(rtS, 0);       /* The model is not direct feedthrough */
  ssSetNumSampleTimes(rtS, 1);          /* Number of sample times */
  ssSetNumBlocks(rtS, 204);             /* Number of blocks */
  ssSetNumBlockIO(rtS, 20);             /* Number of block outputs */
  ssSetNumBlockParams(rtS, 154);        /* Sum of parameter "widths" */
}

/* Function to initialize sample times */
void MdlInitializeSampleTimes(void)
{
  /* task periods */
  ssSetSampleTime(rtS, 0, 0.1);

  /* task offsets */
  ssSetOffsetTime(rtS, 0, 0.0);
}

/* Function to register the model */
SimStruct *emptymodel_1_sm_master(void)
{
  static struct _ssMdlInfo mdlInfo;

  (void) memset((char *)rtS,0,sizeof(SimStruct));
  (void) memset((char *)&mdlInfo,0,sizeof(struct _ssMdlInfo));
  ssSetMdlInfoPtr(rtS, &mdlInfo);

  /* timing info */
  {
    static time_T mdlPeriod[NSAMPLE_TIMES];
    static time_T mdlOffset[NSAMPLE_TIMES];
    static time_T mdlTaskTimes[NSAMPLE_TIMES];
    static int_T mdlTsMap[NSAMPLE_TIMES];
    static int_T mdlSampleHits[NSAMPLE_TIMES];

    {
      int_T i;

      for(i = 0; i < NSAMPLE_TIMES; i++) {
        mdlPeriod[i] = 0.0;
        mdlOffset[i] = 0.0;
        mdlTaskTimes[i] = 0.0;
        mdlTsMap[i] = i;
        mdlSampleHits[i] = 1;
      }
    }

    ssSetSampleTimePtr(rtS, &mdlPeriod[0]);
    ssSetOffsetTimePtr(rtS, &mdlOffset[0]);
    ssSetSampleTimeTaskIDPtr(rtS, &mdlTsMap[0]);
    ssSetTPtr(rtS, &mdlTaskTimes[0]);
    ssSetSampleHitPtr(rtS, &mdlSampleHits[0]);
  }
  ssSetSolverMode(rtS, SOLVER_MODE_SINGLETASKING);

  /*
   * initialize model vectors and cache them in SimStruct
   */

  /* block I/O */
  {
    ssSetBlockIO(rtS, ((void *) &rtB));

    {

      int_T i;
      void *pVoidBlockIORegion;
      pVoidBlockIORegion = (void *)(&rtB.SFunction[0]);
      for (i = 0; i < 72; i++) {
        ((real_T*)pVoidBlockIORegion)[i] = 0.0;
      }
    }
  }

  /* parameters */
  ssSetDefaultParam(rtS, (real_T *) &rtP);

  /* data type work */
  {
    void *dwork = (void *) &rtDWork;
    ssSetRootDWork(rtS, dwork);
    (void) memset((void *) dwork,0,sizeof(D_Work));
  }

  /* Model specific registration */
  ssSetRootSS(rtS, rtS);

  ssSetVersion(rtS, SIMSTRUCT_VERSION_LEVEL2);
  ssSetModelName(rtS, "emptymodel_1_sm_master");
  ssSetPath(rtS, "emptymodel_1_sm_master");

  ssSetTStart(rtS, 0.0);
  ssSetTFinal(rtS, -1);
  ssSetStepSize(rtS, 0.1);
  ssSetFixedStepSize(rtS, 0.1);
  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;

    ssSetRTWLogInfo(rtS, &rt_DataLoggingInfo);

    rtliSetLogFormat(ssGetRTWLogInfo(rtS), 0);

    rtliSetLogMaxRows(ssGetRTWLogInfo(rtS), 1000);

    rtliSetLogDecimation(ssGetRTWLogInfo(rtS), 1);

    rtliSetLogVarNameModifier(ssGetRTWLogInfo(rtS), "rt_");

    rtliSetLogT(ssGetRTWLogInfo(rtS), "tout");

    rtliSetLogX(ssGetRTWLogInfo(rtS), "");

    rtliSetLogXFinal(ssGetRTWLogInfo(rtS), "");

    rtliSetSigLog(ssGetRTWLogInfo(rtS), "");

    rtliSetLogXSignalInfo(ssGetRTWLogInfo(rtS), NULL);

    rtliSetLogXSignalPtrs(ssGetRTWLogInfo(rtS), NULL);

    rtliSetLogY(ssGetRTWLogInfo(rtS), "");

    rtliSetLogYSignalInfo(ssGetRTWLogInfo(rtS), NULL);

    rtliSetLogYSignalPtrs(ssGetRTWLogInfo(rtS), NULL);
  }

  ssSetChecksumVal(rtS, 0, 3608849042U);
  ssSetChecksumVal(rtS, 1, 2076615723U);
  ssSetChecksumVal(rtS, 2, 96261869U);
  ssSetChecksumVal(rtS, 3, 4012880889U);

  /* child S-Function registration */

  ssSetNumSFunctions(rtS, 5);

  /* register each child */
  {
    static SimStruct childSFunctions[5];
    static SimStruct *childSFunctionPtrs[5];

    (void) memset((void *)&childSFunctions[0],0,sizeof(childSFunctions));
    ssSetSFunctions(rtS, &childSFunctionPtrs[0]);
    {
      int_T i;

      for(i = 0; i < 5; i++) {
        ssSetSFunction(rtS, i, &childSFunctions[i]);
      }
    }

    /* Level2 S-Function Block: emptymodel_1_sm_master/<S6>/S-Function (sfun_motor) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 0);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[1];
        _ssSetNumInputPorts(rts, 1);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {
          static real_T const *sfcnUPtrs[8];
          {
            int_T i1;

            const real_T *u0 = rtB.TmpHiddenBufferAtSFunctionInpo;

            for (i1=0; i1 < 8; i1++) {
              sfcnUPtrs[i1] = &u0[i1];
            }
          }
          ssSetInputPortSignalPtrs(rts, 0, (InputPtrsType)&sfcnUPtrs[0]);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 8);
        }
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 8);
          ssSetOutputPortSignal(rts, 0, ((real_T *) rtB.SFunction));
        }
      }

      /* path info */
      ssSetModelName(rts, "S-Function");
      ssSetPath(rts, "emptymodel_1_sm_master/SM_Master/Propeller/S-Function");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* registration */
      sfun_motor(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
    }

    /* Level2 S-Function Block: emptymodel_1_sm_master/<S7>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 1);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 16);
          ssSetOutputPortSignal(rts, 0, ((real_T *) rtB.OpDM6210AnalogIn));
        }
      }

      /* path info */
      ssSetModelName(rts, "Op DM6210 AnalogIn");
      ssSetPath(rts,
       "emptymodel_1_sm_master/SM_Master/Stepmotor/Op DM6210 AnalogIn");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[3];

        ssSetSFcnParamsCount(rts, 3);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, (mxArray*)&rtP.OpDM6210AnalogIn_P1_Size[0]);
        ssSetSFcnParam(rts, 1, (mxArray*)&rtP.OpDM6210AnalogIn_P2_Size[0]);
        ssSetSFcnParam(rts, 2, (mxArray*)&rtP.OpDM6210AnalogIn_P3_Size[0]);
      }

      /* work vectors */
      ssSetIWork(rts, (int_T *) &rtDWork.OpDM6210AnalogIn_IWORK[0]);
      {

        static struct _ssDWorkRecord dWorkRecord[1];

        ssSetSFcnDWork(rts, dWorkRecord);
        _ssSetNumDWork(rts, 1);

        /* IWORK */
        ssSetDWorkWidth(rts, 0, 23);
        ssSetDWorkDataType(rts, 0,SS_INTEGER);
        ssSetDWorkComplexSignal(rts, 0, 0);
        ssSetDWork(rts, 0, &rtDWork.OpDM6210AnalogIn_IWORK[0]);
      }

      /* registration */
      sfun_dm6210_ain(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetOutputPortWidth(rts, 0, 16);
      ssSetOutputPortDataType(rts, 0, SS_DOUBLE);
      ssSetOutputPortComplexSignal(rts, 0, 0);
      ssSetOutputPortFrameData(rts, 0, 0);

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
    }

    /* Level2 S-Function Block: emptymodel_1_sm_master/<S3>/S-Function (OP_SEND) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 2);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[1];
        _ssSetNumInputPorts(rts, 1);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {
          static real_T const *sfcnUPtrs[16];
          sfcnUPtrs[0] = &rtB.u2;
          sfcnUPtrs[1] = &rtB.u;
          sfcnUPtrs[2] = &rtB.SFunction[2];
          sfcnUPtrs[3] = &rtB.SFunction[3];
          sfcnUPtrs[4] = &rtB.u_n;
          sfcnUPtrs[5] = &rtB.u_nz;
          sfcnUPtrs[6] = &rtB.u1;
          sfcnUPtrs[7] = &rtB.u0;
          sfcnUPtrs[8] = &rtB.Sum;
          sfcnUPtrs[9] = &rtB.Sum_d;
          sfcnUPtrs[10] = &rtB.Sum_m;
          sfcnUPtrs[11] = &rtB.Sum_o;
          sfcnUPtrs[12] = &rtB.Sum_df;
          sfcnUPtrs[13] = &rtB.Sum_ox;
          sfcnUPtrs[14] = &rtB.Sum_c;
          sfcnUPtrs[15] = &rtB.Sum_da;
          ssSetInputPortSignalPtrs(rts, 0, (InputPtrsType)&sfcnUPtrs[0]);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 16);
        }
      }

      /* path info */
      ssSetModelName(rts, "S-Function");
      ssSetPath(rts, "emptymodel_1_sm_master/SC_Console/OpSendToNT1/S-Function");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[1];

        ssSetSFcnParamsCount(rts, 1);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, (mxArray*)&rtP.SFunction_P1_Size[0]);
      }

      /* work vectors */
      ssSetIWork(rts, (int_T *) &rtDWork.SFunction_IWORK[0]);
      {

        static struct _ssDWorkRecord dWorkRecord[1];

        ssSetSFcnDWork(rts, dWorkRecord);
        _ssSetNumDWork(rts, 1);

        /* IWORK */
        ssSetDWorkWidth(rts, 0, 5);
        ssSetDWorkDataType(rts, 0,SS_INTEGER);
        ssSetDWorkComplexSignal(rts, 0, 0);
        ssSetDWork(rts, 0, &rtDWork.SFunction_IWORK[0]);
      }

      /* registration */
      OP_SEND(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetInputPortWidth(rts, 0, 16);
      ssSetInputPortDataType(rts, 0, SS_DOUBLE);
      ssSetInputPortComplexSignal(rts, 0, 0);
      ssSetInputPortFrameData(rts, 0, 0);

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
    }

    /* Level2 S-Function Block: emptymodel_1_sm_master/<S8>/S-Function (RECV_Param) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 3);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 16);
          ssSetOutputPortSignal(rts, 0, ((real_T *) rtB.SFunction_i));
        }
      }

      /* path info */
      ssSetModelName(rts, "S-Function");
      ssSetPath(rts,
       "emptymodel_1_sm_master/SM_Master/OpComm/OpRecPar FromNT1 SC_Console/S-Function");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[2];

        ssSetSFcnParamsCount(rts, 2);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, (mxArray*)&rtP.SFunction_P1_Size_i[0]);
        ssSetSFcnParam(rts, 1, (mxArray*)&rtP.SFunction_P2_Size[0]);
      }

      /* registration */
      RECV_Param(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
    }

    /* Level2 S-Function Block: emptymodel_1_sm_master/<S7>/Thruster Orientation motorControll (sfun_stepmotor) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 4);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[1];
        _ssSetNumInputPorts(rts, 1);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {
          static real_T const *sfcnUPtrs[9];
          {
            int_T i1;

            const real_T *u0 = rtB.TmpHiddenBufferAtThrusterOrien;

            for (i1=0; i1 < 9; i1++) {
              sfcnUPtrs[i1] = &u0[i1];
            }
          }
          ssSetInputPortSignalPtrs(rts, 0, (InputPtrsType)&sfcnUPtrs[0]);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 9);
        }
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 1);
          ssSetOutputPortSignal(rts, 0, ((real_T *)
            &rtB.ThrusterOrientationmotorContr));
        }
      }

      /* path info */
      ssSetModelName(rts, "Thruster Orientation motorControll");
      ssSetPath(rts,
       "emptymodel_1_sm_master/SM_Master/Stepmotor/Thruster Orientation motorControll");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* registration */
      sfun_stepmotor(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
    }
  }

  return rtS;
}

