echo   %  M-file
%  This demo tests the worst-case fitness ratio for half-space
%  updatings with polytopes in dimensions 6-7  over 10 repetitions.
%  If this m-file does not run correctly please contact us at
%  Email address: gbt@sysbrain.com
 
%  Define number of samples for each dimension:
 
nosamp=[100, 50, 20, 15, 11, 12, 13, 14, 15]; 
 
%  Initialize of the worst fitting accuracy over all computations:
 
mumax=eps;
 
%  Repeat the random generation of half-sapce 10 times:
 
for j=1:10;
 for i=6:7,
 [j,i]
  F=[rand(nosamp(i-1),i)-0.5 ones(nosamp(i-1),1)];
  P=fconvh(F);
  if fvfitacc(P)>mumax, mumax=fvfitacc(P);end; % update
 end;
end;
 
%  Display the worst-case fitting accuracy as multiple of EPS :
 
disp('Worst-case fitness ratio (=mu/eps):');
mumax/eps
 
echo  
