function H=dualpon(V);
%  DUALPON: compute a set of half-spaces "normal" to a set of vectors
%  Inputs:
%    V[1] = set of points
%  Outputs:
%   H[[1 1]] = set of half-space inequalities
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
%  Define the default values:
 
if nargin<1, V=1;end; H=[1 1];
 
%  List the half-space inequalities with normal directions
%  from `V' and fitted to points in `V':
 
n=size(V,1);H=zeros(n,size(V,2)+1);
for i=1:n, 
   nor=norm(V(i,:));H(i,:)=[V(i,:)/nor nor];
end;
 
return;
