function [f,g]=f_lp(x,A,p),
%  F_LP:  calculate subgradient of cost for LPCENT
%   Inputs:
%   x  -  vector x (row vector)
%   A  -  set of points, each row represents a point
%   p  -  parameter of Chebishev norm
%   Outputs:
%   f  -  value of F(x)
%   g  -  subgradient of F(x) (row vector)
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
%  Direct computation by the follwing formula:
 
[f,irec]=max(sum((abs(ones(size(A,1),1)*x-A).^p)'));
y=x-A(irec,:);g=p*sign(y).*(abs(y).^(p-1));
return;
