function [poly]=mp_ScalePoly(Poly)
% SYNTAX: [poly]=mp_ScalePoly(Poly)
% 
% Description: Scales a polytope such that each row has a length 1. 
%
% Input: Poly=[A b]={x|Ax<=b}
%  
% Output: Poly with normaiized rows. 
%

if isstruct(Poly)
    str=1;
    Poly=Poly.ineqs;
else
    str=0;
end
A=Poly(:,1:end-1);
b=Poly(:,end);
for i=1:size(A,1)
    poly(i,:)=Poly(i,:)/norm(A(i,:));
end
if str
    poly=mp_Poly(poly,true,[],'normalized',true);
end

