function [T,alpha] = opt_qp_f(tau)
%algorithm that with a given tau (desired generalized control, from control system) 
%computes the optimal values of T and
%alpha. Using fesible sectors.

na=8;       %number of actuators 
dof=3;      %degrees of freedom

%Weighting matrises
H=[];
R=1*eye(2*na);
Q=50*eye(dof);
H=2*blkdiag(R,Q);

%optimaliseringsvektor x
u=zeros(2*na,1);
s=zeros(dof,1);
x=[u;s];


forbidWidth=175;
[A,b] = forbiddenSectors(forbidWidth); %function calculation the forbidden sectors for the 8 actuators and stacking them

Auneq=blkdiag(A,zeros(3)); %including the slack-variables
Buneq=[b; zeros(dof,1)];

f=zeros(1,na*2+dof); %f^T*x til optimaliseringen


l=0.4;
Bb=[1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0;
    0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1;
    l l l l -l l -l l -l -l -l -l l -l l -l]; %Check


Aeq=[Bb,eye(3)];
beq=tau;
T_=[];
A_=[];

    
 %Optimazation
 sol = quadprog(H,f,Auneq,Buneq,Aeq,beq,[],[],[],optimset('Display','off','LargeScale','off'));

%Updating
alpha=[];
T=[];
for i=1:na
    ux=sol(i);
    uy=sol(i+1);
    alpha=[alpha; atan2(uy,ux)];             %ATAN2(Y,X) is the four quadrant arctangent of the real parts of the
    T=[T; sqrt(ux^2+uy^2)]  ;                           %     elements of X and Y.  -pi <= ATAN2(Y,X) <= pi.
end











