close all

t=time;
tau1=taucommanded;
tau2=taucomputed;
tau_stat=tau_static;
tau_mpc=tau2;


alpha=simout_alpha;
T=simout_T;

u=simout_u;
u2=simout_u2;
u3=simout_u3;


%All actuators, alpha and T
figure()
i=1;
while i<9  
   subplot(2,4,i), stairs(t,alpha(:,i))
   xlabel('Time [ms]')
   if(i==1 || i==5)
   ylabel('Thruster angle [rad]')
   end
   i=i+1;
end
title('alpha for mpc')

figure()
i=1;
while i<9  
   subplot(2,4,i), stairs(t,T(:,i))
   if(i==1 || i==5)
   ylabel('Thruster magnitude [N]')
   end
   xlabel('Time [ms]')
   i=i+1;
end
title('T for mpc')

figure()
i=1;
while i<9  
   subplot(2,4,i), stairs(t,T_static(:,i))
   if(i==1 || i==5)
   ylabel('Thruster magnitude [N]')
   end
   xlabel('Time [ms]')
   i=i+1;
end
title('T for static')

%Actuator 1, alpha and T
b=1;
e=200;
figure()
subplot(1,2,1), stairs(t(b:e),alpha(b:e,3),'b')
xlabel('Time [ms]')
ylabel('Angle [rad]')
title('\alpha, Actuator 1')

subplot(1,2,2), stairs(t(b:e),T(b:e,3),'r')
title('T, Actuator 1')
xlabel('Time [ms]')
ylabel('Thruster magnitude [N]')

size(alpha(:,1))
size(t)

%horizons:
tauN1=taucomputed;
tauN2=tau_horz2;
tauN3=tau_horz3;

figure()
plot(t,tauN1(:,1),'*')
hold on
plot(t,tauN2(:,1),'b')
plot(t,tauN3(:,1),'o')
hold off
legend('tau N=1','tau N=2','tau n=3')
title('Tau mpc over control horizon')

%check if u, u2, u3 differs
sum(u)
sum(u2)
sum(u3)

sum(u2)-sum(u)


%%tau commanded vs tau stat vs tau mpc:
st=1;
e=200;

t=time(st:e);
p=1
f1=taucommanded(st:e,p);
f2=tau_mpc(st:e,p);
f3=tau_static(st:e,p);
figure()
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f2,'b')
stairs(t,f3,'-.r')
hold off 
legend('\tau commanded','\tau mpc','\tau quasi-static',4)
xlabel('Time [ms]')
ylabel('Force [N]')
title('Surge')

p=2
f1=taucommanded(st:e,p);
f2=tau_mpc(st:e,p);
f3=tau_static(st:e,p);
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f2,'b')
stairs(t,f3,'-.r')
hold off 
xlabel('Time [ms]')
ylabel('Force [N]')
title('Sway')

p=3
f1=taucommanded(st:e,p);
f2=tau_mpc(st:e,p);
f3=tau_static(st:e,p);
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f2,'b')
stairs(t,f3,'-.r')
hold off 
xlabel('Time [ms]')
ylabel('Force [N]')
title('Yaw')


%%tau commanded vs tau mpc:
t=time(st:e);
p=1
f1=taucommanded(st:e,p);
f2=tau_mpc(st:e,p);
figure()
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f2,'b')
hold off 
legend('\tau commanded','\tau mpc',4)
xlabel('Time [ms]')
ylabel('Force [N]')
title('Surge')


p=2
f1=taucommanded(st:e,p);
f2=tau_mpc(st:e,p);
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f2,'b')
hold off 
xlabel('Time [ms]')
ylabel('Force [N]')
title('Sway')


p=3
f1=taucommanded(st:e,p);
f2=tau_mpc(st:e,p);
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f2,'b')
hold off 
xlabel('Time [ms]')
ylabel('Force [N]')
title('Yaw')



%%tau commanded vs tau stat:
t=time(st:e);
p=1
f1=taucommanded(st:e,p);
f3=tau_static(st:e,p);
figure()
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f3,'-.r')
hold off 
legend('\tau commanded','\tau quasi-static',4)
xlabel('Time [ms]')
ylabel('Force [N]')
title('Surge')

p=2
f1=taucommanded(st:e,p);
f3=tau_static(st:e,p);
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f3,'-.r')
hold off 
xlabel('Time [ms]')
ylabel('Force [N]')
title('Sway')

p=3
f1=taucommanded(st:e,p);
f3=tau_static(st:e,p);
subplot(3,1,p)
stairs(t,f1,'g','LineWidth',2)
hold on
stairs(t,f3,'-.r')
hold off 
xlabel('Time [ms]')
ylabel('Force [N]')
title('Yaw')

