%MPC algorithm 3

%clear all;
close all;

na=8;      %number of actuators 
N=3;       %prediksjonshorisont
dof=3;      %degrees of freedom

l1y=0.365; l1x=-0.305;
l2y=0.305; l2x=-0.365;
l3y=-0.305; l3x=-0.365;
l4y=-0.365; l4x=-0.305;
l5y=-0.365; l5x=0.305;
l6y=-0.305; l6x=0.365;
l7y=0.305; l7x=0.365;
l8y=0.365; l8x=0.305;


Bb=[1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0;
    0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1;
    -l1y l1x -l2y l2x -l3y l3x -l4y l4x -l5y l5x -l6y l6x -l7y l7x -l8y l8x]; %Check

%making cost function H
Q1=eye(2*na);
R1=eye(3);
Q=[];
for i=1:N
   Q=blkdiag(Q,2*Q1); 
end
R=[];
for i=1:N
    R=blkdiag(R,i*10*R1);
end
H=blkdiag(Q,R);

H2=blkdiag(eye(2*na*N),zeros(3*N));

[A,b] = forbiddenSectors();
Auneq2=kron(eye(N),A);          %Auneq2: contstraints, forbidden sectors
[m,n]=size(Auneq2);
Auneq2=[Auneq2 zeros(m,3*N)];  %because of slackvariables
buneq2=kron(ones(N,1),b);



% Auneq4=[-eye(N*na*2) zeros(N*na*2,3*N)];
% buneq4=-0.5*ones(N*na*2,1);


%initialization
u0=zeros(2*na,1);
u_k=zeros(2*na,1);
U=[];       %the computed u, over the whole horizon
TAU_=[];    %the computed tau, over the whole horizon

nn = 100; %Number of simulation steps

%Constructing a reference tau (from control system)
r1=mmult([10;10;0], [zeros(1, 20) ones(1, nn/2-20)]);
r2=mmult([-2;-2;0], [zeros(1, 20) ones(1, nn/2-20)]);
r=[r1 r2];

U01=[];
U02=[];
T_=[];
A_=[];
alpha=[];
T=[];
S=[];
%Buneq=buneq;
Aalpha=[]; %Constraints for alpha
balpha=[];
Auneq3=[];
buneq3=[];
Auneq3_forrige=[];
buneq3_forrige=[];
Aa=[];
ba=[];
u_horizon=zeros(1,2*na*N);
tic 

for i=1:nn   
    tau=r(1:3,i);
    %Assuming future tau equal to the present
    %building equality contstraints: Bu=tau
    eq1=kron(eye(N),Bb);
    eq2=eye(3*N);
    Aeq=[eq1 eq2];
    beq=kron(ones(N,1),tau);
    
    f=[u_horizon zeros(1,3*N)]*H2;  %zeros because of slackvariables
        
%   %constraints for alpha and T
     auneq3;
    %auneq3tofile;
    % pause
    
    Auneq=[Auneq2; Auneq3];
    buneq=[buneq2; buneq3];
    
    %Optimazation
    sol = quadprog(H,f,Auneq,buneq,Aeq,beq,[],[],[],optimset('Display','off','LargeScale','off'));
    %sol = quadprog(H,f,[],[],[],[],[],[],[],optimset('Display','off','LargeScale','off')); %without constraints
    
    %Updating
    u0=u_k;
    u_k= sol(1:2*na);
    s_k=sol(2*na+1:2*na+3);
    U(1:2*na,i)=u_k;
    S(1:3,i)=s_k;
    tau_=Bb*u_k;
    TAU_(1:dof,i)=tau_;  
    
    alpha=[];
    T=[];

     k=1;
     while k < na*2
        ux=u_k(k);
        uy=u_k(k+1);
        alpha=[alpha; atan2(uy,ux)];             %ATAN2(Y,X) is the four quadrant arctangent of the real parts of the
        T=[T; sqrt(ux^2+uy^2)]  ;                           %     elements of X and Y.  -pi <= ATAN2(Y,X) <= pi.
        k=k+2;
     end
    
    T_=[T_ T];
    A_=[A_ alpha];
    u_horizon=sol(1:16*N)';
    s_horizon=sol(16*N+1:end);

    size(Auneq3);
    Auneq3_forrige=Auneq3;
    buneq3_forrige=buneq3;
    Auneq3=[];
    buneq3=[];
    %pause   %to see how the constraints move
end

disp(['Simulation took ',num2str(toc),' seconds to complete.'])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%plotting%%%%%%%%%%%%%%%%%%%%%%%%%


figure
t = (1:1:nn);
plot(t,TAU_(1:dof,:),t,r(1:dof,:),'.')
title('Tau computed line, Tau reference dotted')
xlabel('time')
ylabel('Tau')

figure
title('alpha')
subplot(241), plot(t,A_(1,:))
subplot(242), plot(t,A_(2,:))
subplot(243), plot(t,A_(3,:))
subplot(244), plot(t,A_(4,:))
subplot(245), plot(t,A_(5,:))
subplot(246), plot(t,A_(6,:))
subplot(247), plot(t,A_(7,:))
subplot(248), plot(t,A_(8,:))

figure
title('alpha')
plot(t,A_(2,:),'o')
i=1;
while i<length(t)
   plot(t(i), A_(2,i),'o')
   hold on
   i=i+1;
end

figure
title('T')
subplot(241), plot(t,T_(1,:))
subplot(242), plot(t,T_(2,:))
subplot(243), plot(t,T_(3,:))
subplot(244), plot(t,T_(4,:))
subplot(245), plot(t,T_(5,:))
subplot(246), plot(t,T_(6,:))
subplot(247), plot(t,T_(7,:))
subplot(248), plot(t,T_(8,:))

figure
i=1;
k=1;
while i<=16
    subplot(2,4,k), plot(U(i,:),U((i+1),:)), %plotting movement of actuators ux uy
    axis([-2.5 2.5 -2.5 2.5])
    title(['Actuator ',num2str(k)])
%     xlabel('u_x')
%     ylabel('u_y')    
    i=i+2;
    k=k+1;
end

figure
for i=1:16
    subplot(8,2,i), plot(t,U(i,:))  %plotting individual u's as function of time
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

writetofile2


