function [C,nc]=combin(n,k);
%  COMBIN: compute the  k-class combination of n objects
%  Inputs:
%  n[1]  =  number of objects
%  k[1]  =  number of classes
%  Outputs:
%  C[1]  = array of combinations
%   nc   = number of combinations
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  The input/output defaults are defined:
if nargin<2, k=1;elseif nargin<1, n=1; end; 
 
%  The array and number of combinations are set to default values:
C=1;nc=1;
 
%  A special case is dealt with:
if (k<=0), C=[1];nc=1;return;end;
 
%  The array of combinations is built up:
if (k<n), 
  if (k==1), 
    C=(1:n)';nc=n;
    return;
  end;
  C=[];nc=0;
  for i=1:n-k+1,
    [C1,n1]=combin(n-i,k-1);
    C=[C;i*ones(n1,1) C1+i*ones(n1,k-1)];
    nc=nc+n1;
  end;
elseif (n==k),
  C=(1:n);nc=1;
else 
  C=[];nc=0;
end;
 
return;
 
 
