function E=defell(P,c)
%   DEFELL:   define an ellipsoid
%   Inputs:
%    P[1] = defining matrix of ellipsoid
%      c  = centre of ellipsoid
%   Outputs:
%    E[[1 0;1 0]]  = ellipsoid
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  Set the defaults:
 
if nargin<1, P=1;end;
E=[1 0;1 0];
 
%  Diagnose dimensions and default settings:
 
[m1,n]=size(P);
if (m1<1),
  disp('Dimension of object must be at least 1.');break;
end;
if exist('c');
  if (m1 ~= n)|(m1 ~= length(c)), 
    error('Incompatible matrix dimensions in "defell.m" ');
  end; 
  [cr,cc]=size(c); 
  if (cr==1),c=c'; end;
else
  c=zeros(m1,1);
end;  
 
%  Build up ellipsoid matrix in 1D case:
 
if (m1==1), 
  E=[1,1;P(1,1),c];return;
end;
 
%  Build up ellipsoid matrix in general case:
 
E=[1 zeros(1,n);P c];
 
return
 
 
 
