echo % % M-file
%  This demo tests the worst-case fitness ratio for convex hull
%  computations in dimensions 2-7 over 10 repetitions.
%  If this m-file does not run correctly please contact us
%  Email: gbt@sysbrain.compause
 
 
%  Number of damples for each dimension:
 
nosamp=[100, 50, 20, 15, 11, 12, 13, 14, 15]; 
 
%  Initialize  the worst fitting accuracy over all computations:
 
mumax=eps;
 
%  Repeatthe random generation of half-spaces 10 times:
 
for j=1:10;
  for i=2:4,
  [i,j]
  V=rand(nosamp(i-1),i);
  P=convh(V);
  if fvfitacc(P)>mumax, mumax=fvfitacc(P);end;
  end;
end;
 
%  Display the worst-case fitting accuracy in multiples of EPS :
 
disp(' ');
disp('Worst-case fitness ratio (=mu/eps):');
mumax/eps
 
echo  
