echo %  M-file
%  This demo m-file adds three polytopes: two boxes and a random
%  polytope based on convex hull computations.
%  If this m-file does not run correctly please contact us
%  Email: gbt@sysbrain.com
 
%  Define of two boxes:
 
P1=defbox([-1,-2],[2 2]);
P2=defbox(0.1*[-1 -1],0.1*[1 1]);
 
%  Computing the Minkowski sum of the two boxes:
 
P=poladd(P1,P2);
 
%  Extract the vertices and facets of the sum:
 
[v,nv]=vertices(P);[f,nf]=faces(P);
disp('Number of vertices and faces of the box sum:');
[nv,nf]
 
%  Generate a  set of 50 random points:
 
P3=convh(rand(50,2)); % computing convex hull
P4=poladd(P2,P3);     % adding P2 and P3
[v,nv]=vertices(P4);[f,nf]=faces(P4);  % extracting vertices and facets
 
 
%  Display  the number of vertices and facets:
 
disp('Number of vertices and faces of the polytope sum:');
[nv,nf]
 
echo off
