echo %  M-file
%  This demo illustrates the sensitivity of facet updating.
%  In the first part a triangle is cut by a half-space nearly
%  coincident with a side of the triangle. The second part
%  recomputes a random polytope from its facet inequalities.
%  If this m-file does not run correctly please contact us
%  Email: gbt@sysbrain.com
 
 
%  Convex hull of three points:
 
P=convh([0 0;1 0;0 1]);
 
%  Define a half-space with borderline near to an edge:
 
h=[1 1 0.994];
 
%  Update `P' with `h' :
 
P1=update(h,P);
 
%  Viewthe updated and original triangle in the same plot:
 
ax=view2d(P,[1 2 ]);view2d(P1,[1 2 ],'g',ax);
 
 
%  This part generates a random 3D polytopes and recomputes them
%  from their facet inequalities. First extract facets from random polytope:
 
P=convh(rand(10,3));F=faces(P);
 
%  Update with first facet inequality:
 
h=F(1,:);P1=update(h,P);
 
%  View original and updated polytopes in same plot:
 
ax=view2d(P,[1 2 3]);
view2d(P1,[1 2 3],'g',ax);
 
 
echo off; % no.figs=2
