echo % M-file
%  This demo tests the accuracy of the PLANFIT routine .
%  If this m-file does not run correctly please contact
%  by email: gbt@sysbrain.com
 
%  Test for three almost aligned points in 3D space:
 
N=10;ac=(1:N)';
for i=1:N,
   V=[0 0 0;0 1+eps*i 0;0 2 0];
   [a,b,ac(i)]=planfit(V);
end;
 
%  Display the worst-case error of fitting:
 
max(abs(ac/eps))
   
 
%  Generate points for dimensions d=4:10 so that 3rd and 4th points
%  are linear combinations of the first two points and compute the planes fitted:
 
for d=4:10,
	disp('dimension computed:');
	for i=1:N,
 	   V=rand(d,d);
  	   V(3,:)=V(1,:)+V(2,:);
   	   V(4,:)=V(2,:)+0.2*V(1,:);
      [a,b,ac(i)]=planfit(V);
	end;
 
%  Display  the worst case fitting error:
 
	[d, max(abs(ac/eps))]
end;  
 
 
echo off; % no.figs=9
 
