function [d,dactual,mu]=dim(P);
%   DIM:  compute the dimension of a polytope
%  Inputs:
%     P[ [1 eps;1 1] ] = polytope
%  Outputs:
%    d[1]       =  dimension of polytope representation
%    dactual[0] =  actual dimension of polytope
%    mu[eps]    = largest fitting error of facets and vertices
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  Diagnostics:
 
if isempty(P) | size(P,2)==1, 
 d=0;dactual=0;mu=eps;
end;
 
%  Define the default values:
 
if nargin<1, P=[1 eps;1 1];end;
d=1;dactual=0;mu=eps;
 
%  Extract the representation and actual dimensions:
 
d=size(P,2)-1;dactual=d-P(1,1);
 
%  Extract the worst-case fitting error:
 
if d>1,	mu=P(1,3); else mu=eps; end;
return;
 
