function bool=inell(p,E);
%  INELL:  test whether a given point is in an ellipsoid
%  Inputs:
%      p[0]        = point
%      E[1 0;1 0]  = ellipsoid
%  Outputs:
%      bool[1]  = Boolean value
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
 
%  Define defaults:
 
if nargin<2, E=[1 0;1 0];end;
if size(p,2)==1, p=p';end;
 
%  Test if a point is contained in an ellipsoid:
 
d=size(E,2)-1;
P=ellicov(E);cent=E(2:d+1,d+1)';
bool=(p-cent)*pinv(P)*(p-cent)'<1;
return;
