function [O,acc]=poladd(O1,O2,typ);
%  POLADD: compute the sum of two polytopes
%  Inputs:
%    O1[[1 eps;1 0]] = first polytope
%    O2[[1 eps;1 0]] = second polytope
%    typ['numer']    = type of operation
%  Outputs:
%     O[[1 eps;1 0]] = sum of polytopes
%       acc          = max. error of vertex-facet adjacency
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
global V;
 
%  Define default input:
 
if nargin<2, O2=[1 eps;1 0];end;
if nargin<3, typ='numer';end;
 
%  Find global precision bounds:
 
global DELTA;global KAPPA;global ERRFACTOR;
 
%  Activate user interface SETDELTA if not defined:
 
if (isempty(DELTA) | isempty(KAPPA)), H=[];setdelta;end;
 
%  Find out the number of points and dimension of space:
 
%  Perform diagnosis:
 
[nd,d1]=size(O1);[nd2,d2]=size(O2);d=d1-1;
% if (d<1),
%   disp('Dimension of object must be at least 1 in "poladd.m".');  break;
% end;
% if (d~=d2-1),
%   disp('Objects into "poladd.m" are of different formal dimensions.');  break;
% end;
%  
%  Compute V = set of the sums of all combinations of vertices:
 
    [V1,nv1]=vertices(O1);[V2,nv2]=vertices(O2);
    nv12=nv1*nv2;V=zeros(nv12,d);
    for i=1:nv1,
      for j=1:nv2,
        k=(i-1)*nv2+j;V(k,:)=V1(i,:)+V2(j,:);
      end;
    end;
    
%  Comput the convex hull of V that gives the Minkowski sum:
    
 
[O,acc]=convh(V,typ);
return;
