function B=bounded(P);
%  BOUNDED: test whether a polyhedron is bounded
%  Inputs:
%   P   = polytope in GBT 6.1 type 4  format
%  Outputs:
%   B   = Boolean value 0 or 1
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  Diagnostics:
 
B=0;
if (P(1,1)<4), B=1;return; else B=0;end;
[nr,d]=size(P);d=d-1;
if (d<1),
  disp('Dimension of object must be at least 1.');return;
end; 
 
%  Dealing with the 1D case:
 
if (d==1),  
  if (P(1,2)<2),B=0;else B=1;end;
  return;
end;
 
%  Testing for polyhedra of type 4:
 
if (P(1,1)==4),
   nvh=2+P(1,2)+2*P(1,3);
   VV=P(nvh:nr,1:d);
   [rvh,cvh]=size(VV);
   if (rvh>0),
     m=min(min(VV));
   else 
     m=0;
   end;
   if ((rvh<1)|(m==0)), 
     B=0;
   else 
     B=1;
   end;
end;
return;
 
