/*
 * rigalloc_mpc_u_1_sm_master.c
 * 
 * Real-Time Workshop code generation for Simulink model "rigalloc_mpc_u_1_sm_master.mdl".
 *
 * Model Version              : 1.866
 * Real-Time Workshop version : 6.3  (R14SP3)  26-Jul-2005
 * C source code generated on : Fri Oct 19 11:54:24 2007
 */

#include <math.h>
#include "rigalloc_mpc_u_1_sm_master.h"
#include "rigalloc_mpc_u_1_sm_master_private.h"
#include "simstruc.h"
#include "fixedpoint.h"

/* Block signals (auto storage) */
BlockIO rtB;

/* Block states (auto storage) */
D_Work rtDWork;

/* Parent Simstruct */
static SimStruct model_S;
SimStruct *const rtS = &model_S;

/* Initial conditions for root system: '<Root>' */
void MdlInitialize(void)
{

  /* user code (Initialize function Body) */
  /* System: <Root> */
  /* Opal-RT Technologies */
  opalSizeDwork = sizeof(rtDWork);
  if(ssGetNumBlockIO(rtS) != 0)
  opalSizeBlockIO = sizeof(rtB);
  else
  opalSizeBlockIO = 0;
  if(ssGetNumBlockParams(rtS) != 0)
  opalSizeRTP = sizeof(rtP);
  else
  opalSizeRTP = 0;

  /* Level2 S-Function Block: <S7>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S8>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 1);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S10>/S-Function (RECV_Param) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 2);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* S-Function Block: <S2>/S-Function */
  {

    real_T initVector[56] =
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
    {
      int_T i1;

      real_T *dw_DSTATE = &rtDWork.SFunction_DSTATE[0];

      for (i1=0; i1 < 56; i1++) {
        dw_DSTATE[i1] = initVector[i1];
      }
    }
  }

  /* Level2 S-Function Block: <S3>/S-Function (OP_SEND) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 3);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* Level2 S-Function Block: <S8>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);
    sfcnInitializeConditions(rts);
    if(ssGetErrorStatus(rts) != NULL) return;
  }
}

/* Start for root system: '<Root>' */
void MdlStart(void)
{
  MdlInitialize();
}

/* Outputs for root system: '<Root>' */
void MdlOutputs(int_T tid)
{
  /* local block i/o variables*/
  real_T rtb_Sum1_p;
  real_T rtb_Sum1_g;
  real_T rtb_r64_temp89[8];
  real_T rtb_r64_temp90[8];
  real_T rtb_r64_temp91;
  real_T rtb_r64_temp92;
  real_T rtb_r64_temp93;
  real_T rtb_r64_temp94;
  real_T rtb_r64_temp95;
  real_T rtb_r64_temp96;
  real_T rtb_r64_temp97;
  real_T rtb_r64_temp98;
  real_T rtb_r64_temp99;
  real_T rtb_r64_temp100;
  real_T rtb_r64_temp101;
  real_T rtb_r64_temp102;
  real_T rtb_r64_temp103;
  real_T rtb_r64_temp104;
  real_T rtb_r64_temp105;
  real_T rtb_r64_temp106;
  real_T rtb_r64_temp107;

  /* tid is required for a uniform function interface. This system
   * is single rate, and in this case, tid is not accessed. */
  UNUSED_PARAMETER(tid);

  /* Level2 S-Function Block: <S7>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);

    sfcnOutputs(rts, tid);
  }

  /* Gain: '<S7>/-12' */
  rtB.u2 = rtB.SFunction[0] * rtP.u2_Gain;

  /* Gain: '<S7>/-2' */
  rtB.u = rtB.SFunction[1] * rtP.u_Gain;

  /* Gain: '<S7>/-5' */
  rtB.u_a = rtB.SFunction[4] * rtP.u_Gain_a;

  /* Gain: '<S7>/-6' */
  rtB.u_m = rtB.SFunction[5] * rtP.u_Gain_f;

  /* Gain: '<S7>/-11' */
  rtB.u1 = rtB.SFunction[6] * rtP.u1_Gain;

  /* Gain: '<S7>/-10' */
  rtB.u0 = rtB.SFunction[7] * rtP.u0_Gain;

  /* Level2 S-Function Block: <S8>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 1);

    sfcnOutputs(rts, tid);
  }

  /* Sum: '<S12>/Sum1' incorporates:
   *  Sum: '<S12>/Sum2'
   *  Product: '<S12>/Product'
   *  Gain: '<S12>/Unit 2 deg'
   *  Constant: '<S12>/offset'
   *  Constant: '<S12>/min [V] '
   *  Constant: '<S12>/Range [V]'
   */
  rtb_Sum1_p = (rtB.OpDM6210AnalogIn[8] - rtP.minV_Value) / rtP.RangeV_Value *
    rtP.Unit2deg_Gain - rtP.offset_Value;

  /* Gain: '<S21>/Gain' incorporates:
   *  Signum: '<S21>/Sign'
   */
  rtb_r64_temp99 = rt_SGN(rtb_Sum1_p) * rtP.Gain_Gain;

  /* Sum: '<S21>/Sum1' */
  rtb_r64_temp93 = rtb_Sum1_p + rtb_r64_temp99;

  /* Math: '<S21>/Math Function' incorporates:
   *  Constant: '<S21>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value));
      u2Fix = ((rtP.Constant_Value < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value == 0.0) {
      rtb_r64_temp93 = rtNaN;
    } else if ( rtP.Constant_Value == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp93 / rtP.Constant_Value;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp93 = (rtb_r64_temp93 - uDivFix * rtP.Constant_Value);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp93 / rtP.Constant_Value;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp93 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp93 = (uDiv - uDivFix) * rtP.Constant_Value;
      }
    }
  }

  /* Sum: '<S21>/Sum' */
  rtB.Sum = rtb_r64_temp93 - rtb_r64_temp99;

  /* Sum: '<S13>/Sum1' incorporates:
   *  Sum: '<S13>/Sum2'
   *  Product: '<S13>/Product'
   *  Gain: '<S13>/Unit 2 deg'
   *  Constant: '<S13>/offset'
   *  Constant: '<S13>/min [V] '
   *  Constant: '<S13>/Range [V]'
   */
  rtb_Sum1_g = (rtB.OpDM6210AnalogIn[9] - rtP.minV_Value_e) / rtP.RangeV_Value_m
    * rtP.Unit2deg_Gain_g - rtP.offset_Value_o;

  /* Gain: '<S23>/Gain' incorporates:
   *  Signum: '<S23>/Sign'
   */
  rtb_r64_temp100 = rt_SGN(rtb_Sum1_g) * rtP.Gain_Gain_l;

  /* Sum: '<S23>/Sum1' */
  rtb_r64_temp103 = rtb_Sum1_g + rtb_r64_temp100;

  /* Math: '<S23>/Math Function' incorporates:
   *  Constant: '<S23>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_e));
      u2Fix = ((rtP.Constant_Value_e < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_e == 0.0) {
      rtb_r64_temp103 = rtNaN;
    } else if ( rtP.Constant_Value_e == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp103 / rtP.Constant_Value_e;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp103 = (rtb_r64_temp103 - uDivFix * rtP.Constant_Value_e);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp103 / rtP.Constant_Value_e;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp103 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp103 = (uDiv - uDivFix) * rtP.Constant_Value_e;
      }
    }
  }

  /* Sum: '<S23>/Sum' */
  rtB.Sum_g = rtb_r64_temp103 - rtb_r64_temp100;

  /* Sum: '<S14>/Sum1' incorporates:
   *  Sum: '<S14>/Sum2'
   *  Product: '<S14>/Product'
   *  Gain: '<S14>/Unit 2 deg'
   *  Constant: '<S14>/Range [V]'
   *  Constant: '<S14>/min [V] '
   *  Constant: '<S14>/offset'
   */
  rtb_r64_temp93 = (rtB.OpDM6210AnalogIn[10] - rtP.minV_Value_i) /
    rtP.RangeV_Value_j * rtP.Unit2deg_Gain_p - rtP.offset_Value_e;

  /* Gain: '<S25>/Gain' incorporates:
   *  Signum: '<S25>/Sign'
   */
  rtb_r64_temp99 = rt_SGN(rtb_r64_temp93) * rtP.Gain_Gain_o;

  /* Sum: '<S25>/Sum1' */
  rtb_r64_temp104 = rtb_r64_temp93 + rtb_r64_temp99;

  /* Math: '<S25>/Math Function' incorporates:
   *  Constant: '<S25>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_l));
      u2Fix = ((rtP.Constant_Value_l < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_l == 0.0) {
      rtb_r64_temp104 = rtNaN;
    } else if ( rtP.Constant_Value_l == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp104 / rtP.Constant_Value_l;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp104 = (rtb_r64_temp104 - uDivFix * rtP.Constant_Value_l);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp104 / rtP.Constant_Value_l;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp104 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp104 = (uDiv - uDivFix) * rtP.Constant_Value_l;
      }
    }
  }

  /* Sum: '<S25>/Sum' */
  rtB.Sum_i = rtb_r64_temp104 - rtb_r64_temp99;

  /* Sum: '<S15>/Sum1' incorporates:
   *  Sum: '<S15>/Sum2'
   *  Product: '<S15>/Product'
   *  Gain: '<S15>/Unit 2 deg'
   *  Constant: '<S15>/offset'
   *  Constant: '<S15>/min [V] '
   *  Constant: '<S15>/Range [V]'
   */
  rtb_r64_temp103 = (rtB.OpDM6210AnalogIn[11] - rtP.minV_Value_d) /
    rtP.RangeV_Value_n * rtP.Unit2deg_Gain_gu - rtP.offset_Value_ek;

  /* Gain: '<S27>/Gain' incorporates:
   *  Signum: '<S27>/Sign'
   */
  rtb_r64_temp100 = rt_SGN(rtb_r64_temp103) * rtP.Gain_Gain_ol;

  /* Sum: '<S27>/Sum1' */
  rtb_r64_temp95 = rtb_r64_temp103 + rtb_r64_temp100;

  /* Math: '<S27>/Math Function' incorporates:
   *  Constant: '<S27>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_m));
      u2Fix = ((rtP.Constant_Value_m < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_m == 0.0) {
      rtb_r64_temp95 = rtNaN;
    } else if ( rtP.Constant_Value_m == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp95 / rtP.Constant_Value_m;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp95 = (rtb_r64_temp95 - uDivFix * rtP.Constant_Value_m);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp95 / rtP.Constant_Value_m;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp95 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp95 = (uDiv - uDivFix) * rtP.Constant_Value_m;
      }
    }
  }

  /* Sum: '<S27>/Sum' */
  rtB.Sum_a = rtb_r64_temp95 - rtb_r64_temp100;

  /* Sum: '<S16>/Sum1' incorporates:
   *  Sum: '<S16>/Sum2'
   *  Product: '<S16>/Product'
   *  Gain: '<S16>/Unit 2 deg'
   *  Constant: '<S16>/Range [V]'
   *  Constant: '<S16>/offset'
   *  Constant: '<S16>/min [V] '
   */
  rtb_r64_temp104 = (rtB.OpDM6210AnalogIn[12] - rtP.minV_Value_f) /
    rtP.RangeV_Value_ji * rtP.Unit2deg_Gain_d - rtP.offset_Value_i;

  /* Gain: '<S29>/Gain' incorporates:
   *  Signum: '<S29>/Sign'
   */
  rtb_r64_temp99 = rt_SGN(rtb_r64_temp104) * rtP.Gain_Gain_c;

  /* Sum: '<S29>/Sum1' */
  rtb_r64_temp96 = rtb_r64_temp104 + rtb_r64_temp99;

  /* Math: '<S29>/Math Function' incorporates:
   *  Constant: '<S29>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_mv));
      u2Fix = ((rtP.Constant_Value_mv < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_mv == 0.0) {
      rtb_r64_temp96 = rtNaN;
    } else if ( rtP.Constant_Value_mv == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp96 / rtP.Constant_Value_mv;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp96 = (rtb_r64_temp96 - uDivFix * rtP.Constant_Value_mv);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp96 / rtP.Constant_Value_mv;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp96 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp96 = (uDiv - uDivFix) * rtP.Constant_Value_mv;
      }
    }
  }

  /* Sum: '<S29>/Sum' */
  rtB.Sum_m = rtb_r64_temp96 - rtb_r64_temp99;

  /* Sum: '<S17>/Sum1' incorporates:
   *  Sum: '<S17>/Sum2'
   *  Product: '<S17>/Product'
   *  Gain: '<S17>/Unit 2 deg'
   *  Constant: '<S17>/offset'
   *  Constant: '<S17>/min [V] '
   *  Constant: '<S17>/Range [V]'
   */
  rtb_r64_temp95 = (rtB.OpDM6210AnalogIn[13] - rtP.minV_Value_b) /
    rtP.RangeV_Value_b * rtP.Unit2deg_Gain_o - rtP.offset_Value_b;

  /* Gain: '<S31>/Gain' incorporates:
   *  Signum: '<S31>/Sign'
   */
  rtb_r64_temp100 = rt_SGN(rtb_r64_temp95) * rtP.Gain_Gain_m;

  /* Sum: '<S31>/Sum1' */
  rtb_r64_temp94 = rtb_r64_temp95 + rtb_r64_temp100;

  /* Math: '<S31>/Math Function' incorporates:
   *  Constant: '<S31>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_l4));
      u2Fix = ((rtP.Constant_Value_l4 < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_l4 == 0.0) {
      rtb_r64_temp94 = rtNaN;
    } else if ( rtP.Constant_Value_l4 == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp94 / rtP.Constant_Value_l4;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp94 = (rtb_r64_temp94 - uDivFix * rtP.Constant_Value_l4);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp94 / rtP.Constant_Value_l4;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp94 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp94 = (uDiv - uDivFix) * rtP.Constant_Value_l4;
      }
    }
  }

  /* Sum: '<S31>/Sum' */
  rtB.Sum_l = rtb_r64_temp94 - rtb_r64_temp100;

  /* Sum: '<S18>/Sum1' incorporates:
   *  Sum: '<S18>/Sum2'
   *  Product: '<S18>/Product'
   *  Gain: '<S18>/Unit 2 deg'
   *  Constant: '<S18>/offset'
   *  Constant: '<S18>/min [V] '
   *  Constant: '<S18>/Range [V]'
   */
  rtb_r64_temp96 = (rtB.OpDM6210AnalogIn[14] - rtP.minV_Value_p) /
    rtP.RangeV_Value_h * rtP.Unit2deg_Gain_c - rtP.offset_Value_j;

  /* Gain: '<S33>/Gain' incorporates:
   *  Signum: '<S33>/Sign'
   */
  rtb_r64_temp99 = rt_SGN(rtb_r64_temp96) * rtP.Gain_Gain_e;

  /* Sum: '<S33>/Sum1' */
  rtb_r64_temp105 = rtb_r64_temp96 + rtb_r64_temp99;

  /* Math: '<S33>/Math Function' incorporates:
   *  Constant: '<S33>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_ma));
      u2Fix = ((rtP.Constant_Value_ma < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_ma == 0.0) {
      rtb_r64_temp105 = rtNaN;
    } else if ( rtP.Constant_Value_ma == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp105 / rtP.Constant_Value_ma;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp105 = (rtb_r64_temp105 - uDivFix * rtP.Constant_Value_ma);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp105 / rtP.Constant_Value_ma;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp105 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp105 = (uDiv - uDivFix) * rtP.Constant_Value_ma;
      }
    }
  }

  /* Sum: '<S33>/Sum' */
  rtB.Sum_d = rtb_r64_temp105 - rtb_r64_temp99;

  /* Sum: '<S19>/Sum1' incorporates:
   *  Sum: '<S19>/Sum2'
   *  Product: '<S19>/Product'
   *  Gain: '<S19>/Unit 2 deg'
   *  Constant: '<S19>/min [V] '
   *  Constant: '<S19>/offset'
   *  Constant: '<S19>/Range [V]'
   */
  rtb_r64_temp94 = (rtB.OpDM6210AnalogIn[15] - rtP.minV_Value_bh) /
    rtP.RangeV_Value_o * rtP.Unit2deg_Gain_l - rtP.offset_Value_k;

  /* Gain: '<S35>/Gain' incorporates:
   *  Signum: '<S35>/Sign'
   */
  rtb_r64_temp100 = rt_SGN(rtb_r64_temp94) * rtP.Gain_Gain_ob;

  /* Sum: '<S35>/Sum1' */
  rtb_r64_temp106 = rtb_r64_temp94 + rtb_r64_temp100;

  /* Math: '<S35>/Math Function' incorporates:
   *  Constant: '<S35>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_c));
      u2Fix = ((rtP.Constant_Value_c < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_c == 0.0) {
      rtb_r64_temp106 = rtNaN;
    } else if ( rtP.Constant_Value_c == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp106 / rtP.Constant_Value_c;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp106 = (rtb_r64_temp106 - uDivFix * rtP.Constant_Value_c);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp106 / rtP.Constant_Value_c;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp106 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp106 = (uDiv - uDivFix) * rtP.Constant_Value_c;
      }
    }
  }

  /* Sum: '<S35>/Sum' */
  rtB.Sum_c = rtb_r64_temp106 - rtb_r64_temp100;

  /* Level2 S-Function Block: <S10>/S-Function (RECV_Param) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 2);

    sfcnOutputs(rts, tid);
  }

  /* S-Function "mpc_unconstrained_wrapper" Block: <S2>/S-Function */

  mpc_unconstrained_Outputs_wrapper(&rtB.SFunction_j[16], rtB.SFunction_o1,
   rtB.SFunction_o2, rtB.SFunction_o3, &rtDWork.SFunction_DSTATE[0]);

  {
    int32_T i1;
    for(i1 = 0; i1 < 8; i1++) {

      /* Gain: '<S2>/rad2deg' */
      rtB.rad2deg[i1] = rtB.SFunction_o1[i1] * rtP.rad2deg_Gain;

      /* Gain: '<S4>/Gain' */
      rtb_r64_temp89[i1] = rtB.SFunction_o2[i1] * rtP.Gain_Gain_g;

      /* Math: '<S4>/Math Function' */
      if(rtb_r64_temp89[i1] < 0.0) {
        rtb_r64_temp90[i1] = -sqrt(-rtb_r64_temp89[i1]);
      } else {
        rtb_r64_temp90[i1] = sqrt(rtb_r64_temp89[i1]);
      }

      /* Gain: '<S4>/rps2rpm' */
      rtB.rps2rpm[i1] = rtb_r64_temp90[i1] * rtP.rps2rpm_Gain;
    }

    /* Sum: '<S9>/Sum' */
    rtB.Sum_gv = rtB.rad2deg[0] + rtB.SFunction_j[20];

    /* Sum: '<S9>/Sum1' */
    rtB.Sum1 = rtB.rad2deg[1] + rtB.SFunction_j[21];

    /* Sum: '<S9>/Sum2' */
    rtB.Sum2 = rtB.rad2deg[2] + rtB.SFunction_j[22];

    /* Sum: '<S9>/Sum5' */
    rtB.Sum5 = rtB.rad2deg[3] + rtB.SFunction_j[23];

    /* Sum: '<S9>/Sum3' */
    rtB.Sum3 = rtB.rad2deg[4] + rtB.SFunction_j[24];

    /* Sum: '<S9>/Sum6' */
    rtB.Sum6 = rtB.rad2deg[5] + rtB.SFunction_j[25];

    /* Sum: '<S9>/Sum4' */
    rtB.Sum4 = rtB.rad2deg[6] + rtB.SFunction_j[26];

    /* Sum: '<S9>/Sum7' */
    rtB.Sum7 = rtB.rad2deg[7] + rtB.SFunction_j[27];
  }

  /* Level2 S-Function Block: <S3>/S-Function (OP_SEND) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 3);

    sfcnOutputs(rts, tid);
  }

  {
    int32_T i1;

    /* MultiPortSwitch: '<S2>/Multiport Switch' */
    switch((int32_T)rtB.SFunction_j[19]) {
     case 1:
      for(i1 = 0; i1 < 8; i1++) {
        rtb_r64_temp90[i1] = rtB.SFunction_j[i1];
      }
      break;
     case 2:
      rtb_r64_temp90[0] = rtB.Sum_gv;
      rtb_r64_temp90[1] = rtB.Sum1;
      rtb_r64_temp90[2] = rtB.Sum2;
      rtb_r64_temp90[3] = rtB.Sum5;
      rtb_r64_temp90[4] = rtB.Sum3;
      rtb_r64_temp90[5] = rtB.Sum6;
      rtb_r64_temp90[6] = rtB.Sum4;
      rtb_r64_temp90[7] = rtB.Sum7;
      break;
    }

    /* MultiPortSwitch: '<S2>/Multiport Switch1' */
    switch((int32_T)rtB.SFunction_j[19]) {
     case 1:
      for(i1 = 0; i1 < 8; i1++) {
        rtb_r64_temp89[i1] = rtB.SFunction_j[i1+8];
      }
      break;
     case 2:
      for(i1 = 0; i1 < 8; i1++) {
        rtb_r64_temp89[i1] = rtB.rps2rpm[i1];
      }
      break;
    }

    /* SignalConversion: '<S7>/TmpHiddenBufferAtS-FunctionInport1' incorporates:
     *  Saturate: '<S11>/Saturation2'
     *  Gain: '<S7>/-1'
     *  Saturate: '<S11>/Saturation5'
     *  Gain: '<S7>/-3'
     *  Saturate: '<S11>/Saturation6'
     *  Gain: '<S7>/-4'
     *  Saturate: '<S11>/Saturation1'
     *  Gain: '<S7>/-7'
     *  Saturate: '<S11>/Saturation7'
     *  Gain: '<S7>/-8'
     *  Saturate: '<S11>/Saturation8'
     *  Gain: '<S7>/-9'
     *  Saturate: '<S11>/Saturation3'
     *  Saturate: '<S11>/Saturation4'
     */
    rtB.TmpHiddenBufferAtSFunctionInpo[0] = rt_SATURATE(rtb_r64_temp89[0],
     rtP.Saturation1_LowerSat, rtP.Saturation1_UpperSat) * rtP.u_Gain_o;
    rtB.TmpHiddenBufferAtSFunctionInpo[1] = rt_SATURATE(rtb_r64_temp89[1],
     rtP.Saturation2_LowerSat, rtP.Saturation2_UpperSat) * rtP.u_Gain_c;
    rtB.TmpHiddenBufferAtSFunctionInpo[2] = rt_SATURATE(rtb_r64_temp89[4],
     rtP.Saturation5_LowerSat, rtP.Saturation5_UpperSat) * rtP.u_Gain_h;
    rtB.TmpHiddenBufferAtSFunctionInpo[3] = rt_SATURATE(rtb_r64_temp89[5],
     rtP.Saturation6_LowerSat, rtP.Saturation6_UpperSat) * rtP.u_Gain_hp;
    rtB.TmpHiddenBufferAtSFunctionInpo[4] = rt_SATURATE(rtb_r64_temp89[2],
     rtP.Saturation3_LowerSat, rtP.Saturation3_UpperSat);
    rtB.TmpHiddenBufferAtSFunctionInpo[5] = rt_SATURATE(rtb_r64_temp89[3],
     rtP.Saturation4_LowerSat, rtP.Saturation4_UpperSat);
    rtB.TmpHiddenBufferAtSFunctionInpo[6] = rt_SATURATE(rtb_r64_temp89[6],
     rtP.Saturation7_LowerSat, rtP.Saturation7_UpperSat) * rtP.u_Gain_l;
    rtB.TmpHiddenBufferAtSFunctionInpo[7] = rt_SATURATE(rtb_r64_temp89[7],
     rtP.Saturation8_LowerSat, rtP.Saturation8_UpperSat) * rtP.u_Gain_p;

    /* Sum: '<S12>/Sum' */
    rtb_r64_temp98 = rtb_r64_temp90[0] - rtb_Sum1_p;

    /* Gain: '<S20>/Gain' incorporates:
     *  Signum: '<S20>/Sign'
     */
    rtb_r64_temp92 = rt_SGN(rtb_r64_temp98) * rtP.Gain_Gain_g0;

    /* Sum: '<S20>/Sum1' */
    rtb_r64_temp107 = rtb_r64_temp98 + rtb_r64_temp92;
  }

  /* Math: '<S20>/Math Function' incorporates:
   *  Constant: '<S20>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_m5));
      u2Fix = ((rtP.Constant_Value_m5 < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_m5 == 0.0) {
      rtb_r64_temp107 = rtNaN;
    } else if ( rtP.Constant_Value_m5 == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp107 / rtP.Constant_Value_m5;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp107 = (rtb_r64_temp107 - uDivFix * rtP.Constant_Value_m5);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp107 / rtP.Constant_Value_m5;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp107 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp107 = (uDiv - uDivFix) * rtP.Constant_Value_m5;
      }
    }
  }

  /* Gain: '<S12>/Step//deg' incorporates:
   *  Sum: '<S20>/Sum'
   */
  rtb_r64_temp98 = (rtb_r64_temp107 - rtb_r64_temp92) * rtP.Stepdeg_Gain;

  /* Saturate: '<S12>/Saturation' */
  rtb_r64_temp91 = rt_SATURATE(rtb_r64_temp98, rtP.Saturation_LowerSat,
   rtP.Saturation_UpperSat);

  /* Sum: '<S13>/Sum3' */
  rtb_r64_temp98 = rtb_r64_temp90[1] - rtb_Sum1_g;

  /* Gain: '<S22>/Gain' incorporates:
   *  Signum: '<S22>/Sign'
   */
  rtb_r64_temp101 = rt_SGN(rtb_r64_temp98) * rtP.Gain_Gain_mi;

  /* Sum: '<S22>/Sum1' */
  rtb_r64_temp102 = rtb_r64_temp98 + rtb_r64_temp101;

  /* Math: '<S22>/Math Function' incorporates:
   *  Constant: '<S22>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_o));
      u2Fix = ((rtP.Constant_Value_o < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_o == 0.0) {
      rtb_r64_temp102 = rtNaN;
    } else if ( rtP.Constant_Value_o == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp102 / rtP.Constant_Value_o;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp102 = (rtb_r64_temp102 - uDivFix * rtP.Constant_Value_o);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp102 / rtP.Constant_Value_o;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp102 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp102 = (uDiv - uDivFix) * rtP.Constant_Value_o;
      }
    }
  }

  /* Gain: '<S13>/Step//deg1' incorporates:
   *  Sum: '<S22>/Sum'
   */
  rtb_r64_temp107 = (rtb_r64_temp102 - rtb_r64_temp101) * rtP.Stepdeg1_Gain;

  /* Saturate: '<S13>/Saturation' */
  rtb_r64_temp92 = rt_SATURATE(rtb_r64_temp107, rtP.Saturation_LowerSat_c,
   rtP.Saturation_UpperSat_j);

  /* Sum: '<S14>/Sum' */
  rtb_r64_temp107 = rtb_r64_temp90[2] - rtb_r64_temp93;

  /* Gain: '<S24>/Gain' incorporates:
   *  Signum: '<S24>/Sign'
   */
  rtb_r64_temp97 = rt_SGN(rtb_r64_temp107) * rtP.Gain_Gain_j;

  /* Sum: '<S24>/Sum1' */
  rtb_r64_temp106 = rtb_r64_temp107 + rtb_r64_temp97;

  /* Math: '<S24>/Math Function' incorporates:
   *  Constant: '<S24>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_i));
      u2Fix = ((rtP.Constant_Value_i < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_i == 0.0) {
      rtb_r64_temp106 = rtNaN;
    } else if ( rtP.Constant_Value_i == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp106 / rtP.Constant_Value_i;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp106 = (rtb_r64_temp106 - uDivFix * rtP.Constant_Value_i);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp106 / rtP.Constant_Value_i;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp106 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp106 = (uDiv - uDivFix) * rtP.Constant_Value_i;
      }
    }
  }

  /* Gain: '<S14>/Step//deg' incorporates:
   *  Sum: '<S24>/Sum'
   */
  rtb_r64_temp107 = (rtb_r64_temp106 - rtb_r64_temp97) * rtP.Stepdeg_Gain_h;

  /* Saturate: '<S14>/Saturation' */
  rtb_r64_temp98 = rt_SATURATE(rtb_r64_temp107, rtP.Saturation_LowerSat_o,
   rtP.Saturation_UpperSat_m);

  /* Sum: '<S15>/Sum3' */
  rtb_r64_temp107 = rtb_r64_temp90[3] - rtb_r64_temp103;

  /* Gain: '<S26>/Gain' incorporates:
   *  Signum: '<S26>/Sign'
   */
  rtb_r64_temp102 = rt_SGN(rtb_r64_temp107) * rtP.Gain_Gain_h;

  /* Sum: '<S26>/Sum1' */
  rtb_r64_temp105 = rtb_r64_temp107 + rtb_r64_temp102;

  /* Math: '<S26>/Math Function' incorporates:
   *  Constant: '<S26>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_mq));
      u2Fix = ((rtP.Constant_Value_mq < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_mq == 0.0) {
      rtb_r64_temp105 = rtNaN;
    } else if ( rtP.Constant_Value_mq == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp105 / rtP.Constant_Value_mq;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp105 = (rtb_r64_temp105 - uDivFix * rtP.Constant_Value_mq);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp105 / rtP.Constant_Value_mq;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp105 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp105 = (uDiv - uDivFix) * rtP.Constant_Value_mq;
      }
    }
  }

  /* Gain: '<S15>/Step//deg' incorporates:
   *  Sum: '<S26>/Sum'
   */
  rtb_r64_temp107 = (rtb_r64_temp105 - rtb_r64_temp102) * rtP.Stepdeg_Gain_l;

  /* Saturate: '<S15>/Saturation' */
  rtb_r64_temp97 = rt_SATURATE(rtb_r64_temp107, rtP.Saturation_LowerSat_i,
   rtP.Saturation_UpperSat_k);

  /* Sum: '<S16>/Sum' */
  rtb_r64_temp107 = rtb_r64_temp90[4] - rtb_r64_temp104;

  /* Gain: '<S28>/Gain' incorporates:
   *  Signum: '<S28>/Sign'
   */
  rtb_r64_temp106 = rt_SGN(rtb_r64_temp107) * rtP.Gain_Gain_f;

  /* Sum: '<S28>/Sum1' */
  rtb_r64_temp103 = rtb_r64_temp107 + rtb_r64_temp106;

  /* Math: '<S28>/Math Function' incorporates:
   *  Constant: '<S28>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_m2));
      u2Fix = ((rtP.Constant_Value_m2 < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_m2 == 0.0) {
      rtb_r64_temp103 = rtNaN;
    } else if ( rtP.Constant_Value_m2 == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp103 / rtP.Constant_Value_m2;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp103 = (rtb_r64_temp103 - uDivFix * rtP.Constant_Value_m2);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp103 / rtP.Constant_Value_m2;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp103 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp103 = (uDiv - uDivFix) * rtP.Constant_Value_m2;
      }
    }
  }

  /* Gain: '<S16>/Step//deg' incorporates:
   *  Sum: '<S28>/Sum'
   */
  rtb_r64_temp107 = (rtb_r64_temp103 - rtb_r64_temp106) * rtP.Stepdeg_Gain_j;

  /* Saturate: '<S16>/Saturation' */
  rtb_r64_temp101 = rt_SATURATE(rtb_r64_temp107, rtP.Saturation_LowerSat_d,
   rtP.Saturation_UpperSat_mi);

  /* Sum: '<S17>/Sum3' */
  rtb_r64_temp107 = rtb_r64_temp90[5] - rtb_r64_temp95;

  /* Gain: '<S30>/Gain' incorporates:
   *  Signum: '<S30>/Sign'
   */
  rtb_r64_temp105 = rt_SGN(rtb_r64_temp107) * rtP.Gain_Gain_ht;

  /* Sum: '<S30>/Sum1' */
  rtb_r64_temp104 = rtb_r64_temp107 + rtb_r64_temp105;

  /* Math: '<S30>/Math Function' incorporates:
   *  Constant: '<S30>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_h));
      u2Fix = ((rtP.Constant_Value_h < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_h == 0.0) {
      rtb_r64_temp104 = rtNaN;
    } else if ( rtP.Constant_Value_h == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp104 / rtP.Constant_Value_h;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp104 = (rtb_r64_temp104 - uDivFix * rtP.Constant_Value_h);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp104 / rtP.Constant_Value_h;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp104 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp104 = (uDiv - uDivFix) * rtP.Constant_Value_h;
      }
    }
  }

  /* Gain: '<S17>/Step//deg' incorporates:
   *  Sum: '<S30>/Sum'
   */
  rtb_r64_temp107 = (rtb_r64_temp104 - rtb_r64_temp105) * rtP.Stepdeg_Gain_i;

  /* Saturate: '<S17>/Saturation' */
  rtb_r64_temp102 = rt_SATURATE(rtb_r64_temp107, rtP.Saturation_LowerSat_b,
   rtP.Saturation_UpperSat_g);

  /* Sum: '<S18>/Sum' */
  rtb_r64_temp107 = rtb_r64_temp90[6] - rtb_r64_temp96;

  /* Gain: '<S32>/Gain' incorporates:
   *  Signum: '<S32>/Sign'
   */
  rtb_r64_temp95 = rt_SGN(rtb_r64_temp107) * rtP.Gain_Gain_lc;

  /* Sum: '<S32>/Sum1' */
  rtb_r64_temp103 = rtb_r64_temp107 + rtb_r64_temp95;

  /* Math: '<S32>/Math Function' incorporates:
   *  Constant: '<S32>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_oi));
      u2Fix = ((rtP.Constant_Value_oi < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_oi == 0.0) {
      rtb_r64_temp103 = rtNaN;
    } else if ( rtP.Constant_Value_oi == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp103 / rtP.Constant_Value_oi;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp103 = (rtb_r64_temp103 - uDivFix * rtP.Constant_Value_oi);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp103 / rtP.Constant_Value_oi;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp103 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp103 = (uDiv - uDivFix) * rtP.Constant_Value_oi;
      }
    }
  }

  /* Gain: '<S18>/Step//deg' incorporates:
   *  Sum: '<S32>/Sum'
   */
  rtb_r64_temp107 = (rtb_r64_temp103 - rtb_r64_temp95) * rtP.Stepdeg_Gain_a;

  /* Saturate: '<S18>/Saturation' */
  rtb_r64_temp106 = rt_SATURATE(rtb_r64_temp107, rtP.Saturation_LowerSat_bj,
   rtP.Saturation_UpperSat_h);

  /* Sum: '<S19>/Sum3' */
  rtb_r64_temp107 = rtb_r64_temp90[7] - rtb_r64_temp94;

  /* Gain: '<S34>/Gain' incorporates:
   *  Signum: '<S34>/Sign'
   */
  rtb_r64_temp96 = rt_SGN(rtb_r64_temp107) * rtP.Gain_Gain_cl;

  /* Sum: '<S34>/Sum1' */
  rtb_r64_temp104 = rtb_r64_temp107 + rtb_r64_temp96;

  /* Math: '<S34>/Math Function' incorporates:
   *  Constant: '<S34>/Constant'
   */
  /* Operator : rem */
  {
    real_T u2Fix;
    real_T uDiv;
    real_T uDivFix;
    {
      real_T t;
      t = floor(fabs(rtP.Constant_Value_a));
      u2Fix = ((rtP.Constant_Value_a < 0.0) ? -t : t);
    }

    if (rtP.Constant_Value_a == 0.0) {
      rtb_r64_temp104 = rtNaN;
    } else if ( rtP.Constant_Value_a == u2Fix ) {
      /* Integer denominator.  Use conventional formula.*/
      uDiv = rtb_r64_temp104 / rtP.Constant_Value_a;
      {
        real_T t;
        t = floor(fabs(uDiv));
        uDivFix = ((uDiv < 0.0) ? -t : t);
      }

      rtb_r64_temp104 = (rtb_r64_temp104 - uDivFix * rtP.Constant_Value_a);
    } else {
      /* Noninteger denominator. Check for nearly integer quotient.*/
      real_T uDivRound;
      uDiv = rtb_r64_temp104 / rtP.Constant_Value_a;
      {
        real_T t;
        t = floor((fabs(uDiv) + 0.5));
        uDivRound = ((uDiv < 0.0) ? -t : t);
      }

      if (fabs((uDiv - uDivRound)) <= DBL_EPSILON * fabs(uDiv)) {
        rtb_r64_temp104 = 0.0;
      } else {
        {
          real_T t;
          t = floor(fabs(uDiv));
          uDivFix = ((uDiv < 0.0) ? -t : t);
        }

        rtb_r64_temp104 = (uDiv - uDivFix) * rtP.Constant_Value_a;
      }
    }
  }

  /* Gain: '<S19>/Step//deg' incorporates:
   *  Sum: '<S34>/Sum'
   */
  rtb_r64_temp107 = (rtb_r64_temp104 - rtb_r64_temp96) * rtP.Stepdeg_Gain_p;

  /* Saturate: '<S19>/Saturation' */
  rtb_r64_temp105 = rt_SATURATE(rtb_r64_temp107, rtP.Saturation_LowerSat_p,
   rtP.Saturation_UpperSat_o);

  /* Level2 S-Function Block: <S8>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);

    sfcnOutputs(rts, tid);
  }

  /* SignalConversion: '<S8>/TmpHiddenBufferAtThruster Orientation motorControllInport1' incorporates:
   *  Constant: '<S8>/dummy (this axe is not used)'
   */
  rtB.TmpHiddenBufferAtThrusterOrien[0] = rtb_r64_temp91;
  rtB.TmpHiddenBufferAtThrusterOrien[1] = rtb_r64_temp92;
  rtB.TmpHiddenBufferAtThrusterOrien[2] = rtb_r64_temp98;
  rtB.TmpHiddenBufferAtThrusterOrien[3] = rtb_r64_temp106;
  rtB.TmpHiddenBufferAtThrusterOrien[4] = rtb_r64_temp105;
  rtB.TmpHiddenBufferAtThrusterOrien[5] = rtb_r64_temp97;
  rtB.TmpHiddenBufferAtThrusterOrien[6] = rtb_r64_temp101;
  rtB.TmpHiddenBufferAtThrusterOrien[7] = rtb_r64_temp102;
  rtB.TmpHiddenBufferAtThrusterOrien[8] = rtP.dummythisaxeisnotused;
}

/* Update for root system: '<Root>' */
void MdlUpdate(int_T tid)
{

  /* tid is required for a uniform function interface. This system
   * is single rate, and in this case, tid is not accessed. */
  UNUSED_PARAMETER(tid);

  /* Level2 S-Function Block: <S7>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);

    sfcnUpdate(rts, tid);
    if(ssGetErrorStatus(rts) != NULL) return;
  }

  /* S-Function "mpc_unconstrained_wrapper" Block: <S2>/S-Function */

  mpc_unconstrained_Update_wrapper(&rtB.SFunction_j[16], rtB.SFunction_o1,
   rtB.SFunction_o2, rtB.SFunction_o3, &rtDWork.SFunction_DSTATE[0]);

  /* Level2 S-Function Block: <S8>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);

    sfcnUpdate(rts, tid);
    if(ssGetErrorStatus(rts) != NULL) return;
  }
}

/* Terminate for root system: '<Root>' */
void MdlTerminate(void)
{

  /* Level2 S-Function Block: <S7>/S-Function (sfun_motor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 0);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S8>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 1);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S10>/S-Function (RECV_Param) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 2);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S3>/S-Function (OP_SEND) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 3);
    sfcnTerminate(rts);
  }

  /* Level2 S-Function Block: <S8>/Thruster Orientation motorControll (sfun_stepmotor) */
  {
    SimStruct *rts = ssGetSFunction(rtS, 4);
    sfcnTerminate(rts);
  }
}

/* Function to initialize sizes */
void MdlInitializeSizes(void)
{
  ssSetNumContStates(rtS, 0);           /* Number of continuous states */
  ssSetNumY(rtS, 0);                    /* Number of model outputs */
  ssSetNumU(rtS, 0);                    /* Number of model inputs */
  ssSetDirectFeedThrough(rtS, 0);       /* The model is not direct feedthrough */
  ssSetNumSampleTimes(rtS, 1);          /* Number of sample times */
  ssSetNumBlocks(rtS, 219);             /* Number of blocks */
  ssSetNumBlockIO(rtS, 33);             /* Number of block outputs */
  ssSetNumBlockParams(rtS, 169);        /* Sum of parameter "widths" */
}

/* Function to initialize sample times */
void MdlInitializeSampleTimes(void)
{
  /* task periods */
  ssSetSampleTime(rtS, 0, 0.1);

  /* task offsets */
  ssSetOffsetTime(rtS, 0, 0.0);
}

/* Function to register the model */
SimStruct *rigalloc_mpc_u_1_sm_master(void)
{
  static struct _ssMdlInfo mdlInfo;

  (void) memset((char *)rtS,0,sizeof(SimStruct));
  (void) memset((char *)&mdlInfo,0,sizeof(struct _ssMdlInfo));
  ssSetMdlInfoPtr(rtS, &mdlInfo);

  /* timing info */
  {
    static time_T mdlPeriod[NSAMPLE_TIMES];
    static time_T mdlOffset[NSAMPLE_TIMES];
    static time_T mdlTaskTimes[NSAMPLE_TIMES];
    static int_T mdlTsMap[NSAMPLE_TIMES];
    static int_T mdlSampleHits[NSAMPLE_TIMES];

    {
      int_T i;

      for(i = 0; i < NSAMPLE_TIMES; i++) {
        mdlPeriod[i] = 0.0;
        mdlOffset[i] = 0.0;
        mdlTaskTimes[i] = 0.0;
        mdlTsMap[i] = i;
        mdlSampleHits[i] = 1;
      }
    }

    ssSetSampleTimePtr(rtS, &mdlPeriod[0]);
    ssSetOffsetTimePtr(rtS, &mdlOffset[0]);
    ssSetSampleTimeTaskIDPtr(rtS, &mdlTsMap[0]);
    ssSetTPtr(rtS, &mdlTaskTimes[0]);
    ssSetSampleHitPtr(rtS, &mdlSampleHits[0]);
  }
  ssSetSolverMode(rtS, SOLVER_MODE_SINGLETASKING);

  /*
   * initialize model vectors and cache them in SimStruct
   */

  /* block I/O */
  {
    ssSetBlockIO(rtS, ((void *) &rtB));

    {

      int_T i;
      void *pVoidBlockIORegion;
      pVoidBlockIORegion = (void *)(&rtB.SFunction[0]);
      for (i = 0; i < 172; i++) {
        ((real_T*)pVoidBlockIORegion)[i] = 0.0;
      }
    }
  }

  /* parameters */
  ssSetDefaultParam(rtS, (real_T *) &rtP);

  /* data type work */
  {
    void *dwork = (void *) &rtDWork;
    ssSetRootDWork(rtS, dwork);
    (void) memset((void *) dwork,0,sizeof(D_Work));
    {
      int_T i;
      real_T *dwork_ptr = (real_T *) &rtDWork.SFunction_DSTATE[0];

      for (i = 0; i < 56; i++) {
        dwork_ptr[i] = 0.0;
      }
    }
  }

  /* Model specific registration */
  ssSetRootSS(rtS, rtS);

  ssSetVersion(rtS, SIMSTRUCT_VERSION_LEVEL2);
  ssSetModelName(rtS, "rigalloc_mpc_u_1_sm_master");
  ssSetPath(rtS, "rigalloc_mpc_u_1_sm_master");

  ssSetTStart(rtS, 0.0);
  ssSetTFinal(rtS, -1);
  ssSetStepSize(rtS, 0.1);
  ssSetFixedStepSize(rtS, 0.1);
  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;

    ssSetRTWLogInfo(rtS, &rt_DataLoggingInfo);

    rtliSetLogFormat(ssGetRTWLogInfo(rtS), 0);

    rtliSetLogMaxRows(ssGetRTWLogInfo(rtS), 1000);

    rtliSetLogDecimation(ssGetRTWLogInfo(rtS), 1);

    rtliSetLogVarNameModifier(ssGetRTWLogInfo(rtS), "rt_");

    rtliSetLogT(ssGetRTWLogInfo(rtS), "tout");

    rtliSetLogX(ssGetRTWLogInfo(rtS), "");

    rtliSetLogXFinal(ssGetRTWLogInfo(rtS), "");

    rtliSetSigLog(ssGetRTWLogInfo(rtS), "");

    rtliSetLogXSignalInfo(ssGetRTWLogInfo(rtS), NULL);

    rtliSetLogXSignalPtrs(ssGetRTWLogInfo(rtS), NULL);

    rtliSetLogY(ssGetRTWLogInfo(rtS), "");

    rtliSetLogYSignalInfo(ssGetRTWLogInfo(rtS), NULL);

    rtliSetLogYSignalPtrs(ssGetRTWLogInfo(rtS), NULL);
  }

  ssSetChecksumVal(rtS, 0, 3255898539U);
  ssSetChecksumVal(rtS, 1, 777978760U);
  ssSetChecksumVal(rtS, 2, 1107843621U);
  ssSetChecksumVal(rtS, 3, 2358213963U);

  /* child S-Function registration */

  ssSetNumSFunctions(rtS, 5);

  /* register each child */
  {
    static SimStruct childSFunctions[5];
    static SimStruct *childSFunctionPtrs[5];

    (void) memset((void *)&childSFunctions[0],0,sizeof(childSFunctions));
    ssSetSFunctions(rtS, &childSFunctionPtrs[0]);
    {
      int_T i;

      for(i = 0; i < 5; i++) {
        ssSetSFunction(rtS, i, &childSFunctions[i]);
      }
    }

    /* Level2 S-Function Block: rigalloc_mpc_u_1_sm_master/<S7>/S-Function (sfun_motor) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 0);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[1];
        _ssSetNumInputPorts(rts, 1);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {
          static real_T const *sfcnUPtrs[8];
          {
            int_T i1;

            const real_T *u0 = rtB.TmpHiddenBufferAtSFunctionInpo;

            for (i1=0; i1 < 8; i1++) {
              sfcnUPtrs[i1] = &u0[i1];
            }
          }
          ssSetInputPortSignalPtrs(rts, 0, (InputPtrsType)&sfcnUPtrs[0]);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 8);
        }
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 8);
          ssSetOutputPortSignal(rts, 0, ((real_T *) rtB.SFunction));
        }
      }

      /* path info */
      ssSetModelName(rts, "S-Function");
      ssSetPath(rts,
       "rigalloc_mpc_u_1_sm_master/SM_Master/Propeller/S-Function");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* registration */
      sfun_motor(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
    }

    /* Level2 S-Function Block: rigalloc_mpc_u_1_sm_master/<S8>/Op DM6210 AnalogIn (sfun_dm6210_ain) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 1);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 16);
          ssSetOutputPortSignal(rts, 0, ((real_T *) rtB.OpDM6210AnalogIn));
        }
      }

      /* path info */
      ssSetModelName(rts, "Op DM6210 AnalogIn");
      ssSetPath(rts,
       "rigalloc_mpc_u_1_sm_master/SM_Master/Stepmotor/Op DM6210 AnalogIn");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[3];

        ssSetSFcnParamsCount(rts, 3);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, (mxArray*)&rtP.OpDM6210AnalogIn_P1_Size[0]);
        ssSetSFcnParam(rts, 1, (mxArray*)&rtP.OpDM6210AnalogIn_P2_Size[0]);
        ssSetSFcnParam(rts, 2, (mxArray*)&rtP.OpDM6210AnalogIn_P3_Size[0]);
      }

      /* work vectors */
      ssSetIWork(rts, (int_T *) &rtDWork.OpDM6210AnalogIn_IWORK[0]);
      {

        static struct _ssDWorkRecord dWorkRecord[1];

        ssSetSFcnDWork(rts, dWorkRecord);
        _ssSetNumDWork(rts, 1);

        /* IWORK */
        ssSetDWorkWidth(rts, 0, 23);
        ssSetDWorkDataType(rts, 0,SS_INTEGER);
        ssSetDWorkComplexSignal(rts, 0, 0);
        ssSetDWork(rts, 0, &rtDWork.OpDM6210AnalogIn_IWORK[0]);
      }

      /* registration */
      sfun_dm6210_ain(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetOutputPortWidth(rts, 0, 16);
      ssSetOutputPortDataType(rts, 0, SS_DOUBLE);
      ssSetOutputPortComplexSignal(rts, 0, 0);
      ssSetOutputPortFrameData(rts, 0, 0);

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
    }

    /* Level2 S-Function Block: rigalloc_mpc_u_1_sm_master/<S10>/S-Function (RECV_Param) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 2);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 28);
          ssSetOutputPortSignal(rts, 0, ((real_T *) rtB.SFunction_j));
        }
      }

      /* path info */
      ssSetModelName(rts, "S-Function");
      ssSetPath(rts,
       "rigalloc_mpc_u_1_sm_master/SM_Master/OpComm/OpRecPar FromNT1 SC_Console/S-Function");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[2];

        ssSetSFcnParamsCount(rts, 2);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, (mxArray*)&rtP.SFunction_P1_Size[0]);
        ssSetSFcnParam(rts, 1, (mxArray*)&rtP.SFunction_P2_Size[0]);
      }

      /* registration */
      RECV_Param(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
    }

    /* Level2 S-Function Block: rigalloc_mpc_u_1_sm_master/<S3>/S-Function (OP_SEND) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 3);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[1];
        _ssSetNumInputPorts(rts, 1);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {
          static real_T const *sfcnUPtrs[88];
          sfcnUPtrs[0] = &rtB.u2;
          sfcnUPtrs[1] = &rtB.u;
          sfcnUPtrs[2] = &rtB.SFunction[2];
          sfcnUPtrs[3] = &rtB.SFunction[3];
          sfcnUPtrs[4] = &rtB.u_a;
          sfcnUPtrs[5] = &rtB.u_m;
          sfcnUPtrs[6] = &rtB.u1;
          sfcnUPtrs[7] = &rtB.u0;
          sfcnUPtrs[8] = &rtB.Sum;
          sfcnUPtrs[9] = &rtB.Sum_g;
          sfcnUPtrs[10] = &rtB.Sum_i;
          sfcnUPtrs[11] = &rtB.Sum_a;
          sfcnUPtrs[12] = &rtB.Sum_m;
          sfcnUPtrs[13] = &rtB.Sum_l;
          sfcnUPtrs[14] = &rtB.Sum_d;
          sfcnUPtrs[15] = &rtB.Sum_c;
          {
            int_T i1;

            const real_T *u0 = &rtB.SFunction_o3[0];

            for (i1=0; i1 < 48; i1++) {
              sfcnUPtrs[i1+ 16] = &u0[i1];
            }
            sfcnUPtrs[64] = &rtB.Sum_gv;
            sfcnUPtrs[65] = &rtB.Sum1;
            sfcnUPtrs[66] = &rtB.Sum2;
            sfcnUPtrs[67] = &rtB.Sum5;
            sfcnUPtrs[68] = &rtB.Sum3;
            sfcnUPtrs[69] = &rtB.Sum6;
            sfcnUPtrs[70] = &rtB.Sum4;
            sfcnUPtrs[71] = &rtB.Sum7;

            u0 = &rtB.rps2rpm[0];

            for (i1=0; i1 < 8; i1++) {
              sfcnUPtrs[i1+ 72] = &u0[i1];
            }

            u0 = &rtB.rad2deg[0];

            for (i1=0; i1 < 8; i1++) {
              sfcnUPtrs[i1+ 80] = &u0[i1];
            }
          }
          ssSetInputPortSignalPtrs(rts, 0, (InputPtrsType)&sfcnUPtrs[0]);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 88);
        }
      }

      /* path info */
      ssSetModelName(rts, "S-Function");
      ssSetPath(rts,
       "rigalloc_mpc_u_1_sm_master/SC_Console/OpSendToNT1/S-Function");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[1];

        ssSetSFcnParamsCount(rts, 1);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, (mxArray*)&rtP.SFunction_P1_Size_j[0]);
      }

      /* work vectors */
      ssSetIWork(rts, (int_T *) &rtDWork.SFunction_IWORK[0]);
      {

        static struct _ssDWorkRecord dWorkRecord[1];

        ssSetSFcnDWork(rts, dWorkRecord);
        _ssSetNumDWork(rts, 1);

        /* IWORK */
        ssSetDWorkWidth(rts, 0, 5);
        ssSetDWorkDataType(rts, 0,SS_INTEGER);
        ssSetDWorkComplexSignal(rts, 0, 0);
        ssSetDWork(rts, 0, &rtDWork.SFunction_IWORK[0]);
      }

      /* registration */
      OP_SEND(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetInputPortWidth(rts, 0, 88);
      ssSetInputPortDataType(rts, 0, SS_DOUBLE);
      ssSetInputPortComplexSignal(rts, 0, 0);
      ssSetInputPortFrameData(rts, 0, 0);

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
    }

    /* Level2 S-Function Block: rigalloc_mpc_u_1_sm_master/<S8>/Thruster Orientation motorControll (sfun_stepmotor) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 4);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      (void) memset((void*)sfcnPeriod,0,sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset,0,sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));

      /* Allocate memory of model methods 2 */
      {
        static struct _ssSFcnModelMethods2 methods2;
        ssSetModelMethods2(rts, &methods2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[1];
        _ssSetNumInputPorts(rts, 1);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {
          static real_T const *sfcnUPtrs[9];
          {
            int_T i1;

            const real_T *u0 = rtB.TmpHiddenBufferAtThrusterOrien;

            for (i1=0; i1 < 9; i1++) {
              sfcnUPtrs[i1] = &u0[i1];
            }
          }
          ssSetInputPortSignalPtrs(rts, 0, (InputPtrsType)&sfcnUPtrs[0]);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 9);
        }
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 1);
          ssSetOutputPortSignal(rts, 0, ((real_T *)
            &rtB.ThrusterOrientationmotorContr));
        }
      }

      /* path info */
      ssSetModelName(rts, "Thruster Orientation motorControll");
      ssSetPath(rts,
       "rigalloc_mpc_u_1_sm_master/SM_Master/Stepmotor/Thruster Orientation motorControll");
      if (ssGetRTModel(rtS) == NULL) {
        ssSetParentSS(rts, rtS);
        ssSetRootSS(rts, ssGetRootSS(rtS));
      } else {
        ssSetRTModel(rts,ssGetRTModel(rtS));
        ssSetParentSS(rts, NULL);
        ssSetRootSS(rts, rts);
      }
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* registration */
      sfun_stepmotor(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.1);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */

      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
    }
  }

  return rtS;
}

