echo % % M-file
%  This demo simulates 5 random sets of 5 spheres
%  and computes the area of the joining flat surfaces.
%  If this m-file does not run correctly please contact
%  by email: gbt@sysbrain.com
%   Five ellipsoids are defined for each of 10 simulations:
 
N=5;est=0; % initialize
for j=1:N,
  E1=defell(eye(3));
  E2=defell(eye(3),rand(1,3)-0.5);
  E3=defell(eye(3),rand(1,3)-0.5);
  E4=defell(eye(3),rand(1,3)-0.5);
  E5=defell(eye(3),rand(1,3)-0.5);
  E=[E1;E2;E3;E4;E5];
 
%  The total ``joining surface" is computed:
 
  [e,o,i]=sphsep(E);
  disp(' Exp. No., the estimate (e), upper bound(o), lower bound (i):'); 
   [e,o,i]
  est=est+e;
end;
 
%  The average surface area over 10 simulations is estimated an displayed:
 
disp('Average of joining surface area:');
est/N
echo
