echo  %  M-file
%  This demo computes a maximal polytope `inside' a set of points (not optimal procedure).
%  First generates a random set of points around the origin
%  and leaves out points near the origin. Then it constructs a
%  polytope inside the set of points.
%  If this m-file does not run correctly please contact us
%  Email: gbt@sysbrain.com
 
%  Generate random set of points with empty space in the middle:
 
N=30;d=2;  % number of points and dimension 
nV=rand(N,d)-0.5;V=[];
 
%  Eliminate points near to origin:
 
for i=1:N,if norm(nV(i,:))>0.25, V=[V;nV(i,:)];end;end;
 
%  Compute the "associated set of half-spaces" to the set of points V:
 
H=dualpon(V);
 
%  Intersect the "associated dual set of half-spaces" H :
 
P=fconvh(H);
 
%   Display original points and largest polytope P inside the set of points:
 
figure;ax=newplot;plot(V(:,1),V(:,2),'x');
view2d(P,[1 2 ],'g',ax);
 
 
echo off; %  no.figs=1
