echo %   M-file
%  This demo m-file estimates the volume of the intersection of
%  30 ellipsoids in 4D.
%  If this m-file does not run correctly please contact us
%  Email: gbt@sysbrain.com
 
 
%  Generate 3 random 4D ellipsoids:
 
d=4;  % dimension
n=3;  % no of ellipsoids
E=zeros(d+1,d+1,n);
for i=1:n,
   C=rand(20,d)-0.5;C=C'*C/2;
   E(:,:,i)=defell(C,0.1*rand(d,1));
end;
 
%  View  of the ellipsoids by projections onto 1-2-3-4 axes:
 
E1=[]; bool=1>0;
ax=view2del(E(:,:,1),[1 2 3 4]);
for i=2:n,
   E1=[E1;E(:,:,i)];
   view2del(E(:,:,i),[1 2 3 4],'blue',ax,'-',100,bool);
end;
 
%  Use the Monte-Carlo volume routine MCVOL:
 
vol=mcvol(E1,10)
 
echo off; % no.figs=1
 
