function [diam,ds,de,ij,j1]=diamet(V);
%   DIAMET: compute the diameter of a set of points
%   Inputs:
%    V[1] = set of points
%   Outputs:
%    diam[0] =  length of diameter
%     ds[1]  =  starting point of a diameter
%     de[1]  =  ending point of a diameter
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%   Define default values:
 
if nargin<1, V=[1 ];end;
diam=0;ds=1;de=1;
 
%   Deal with the 1D case:
 
[nv,d]=size(V);
 if (d==1),
     [ds,ij]=min(V);[de,j1]=max(V);diam=de-ds;
	  return;
 end;
  
 
%  Deal  with the general case:
 
  W=V*V';Z=diag(W)*ones(1,nv);X=Z+Z'-2*W;
  [cx,i]=max(X);[d0,j]=max(cx);
  ds=V(i(j(1)),:)';de=V(j(1),:)';
  ij=i(j(1));j1=j(1);
  diam=sqrt((de-ds)'*(de-ds));
 
return;
 
