function C=ellicov(E);
%  ELLICOV: extracts the matrix of an ellipsoid.
%  Inputs:
%     E[[1 0;1 0]] = ellipsoid
%     C[1]  =  matrix of ellipsoid
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  Set the defaults:
 
if nargin<1, E=[1 0;1 0];end;
 
%  Perform diagnosis:
 
[er,ec]=size(E);
if (ec<2),
  disp(' Dimension must be at least 1.');break;
end;
 
%  Extract the covariance matrix:
 
C=E(2:ec,1:ec-1);
return;
 
 
