function [vmin,vmax]=ellrange(P);
%  ELLRANGE: compute the width (range) of ellipsoid in each dimension
%  Inputs:
%     P[[1 0;1 0]]   = ellipsoid
%  Outputs:
%     vmin[-1]   = low-vector of range
%     vmax[ 1]   = high vector of range
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
%  Set default values:
 
if nargin<1, P=[1 0;1 0];end;
 
%  Calculate the range vector of  ellipsoid in each axes
%  by the formula $c\pm \sqrt{\mbox{diag}(P)$ :
 
  [er,ec]=size(P);d=er-1;
  PC=sqrt(diag(ellicov(P)))';
  c=ellcent(P)';
  vmin=c-PC;
  vmax=c+PC;
  
return;
 
 
 
 
