function P=elltran(P0,A,a);
%  ELLTRAN: compute the affine transform of an ellipsoid
%  Inputs:
%      P0   =   ellipsoid
%      A    =   affin transform matrix
%      a    =   offset of affine transform
%  Outputs:
%     P     =   ellipsoid
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%   Set the dimension :
 
d=size(P0,2)-1;
 
%  Set default value:
 
if nargin<3, a=zeros(d,1);end;
 
%  Compute the transform:
 
ellcent(P0);
P=[1 zeros(1,d);A*ellicov(P0)*A' A*ellcent(P0)+a];
 
return;
