function [v,nV]=firstequ(V);
%  FIRSTEQU: combine points near the first point in a list
%  Inputs:
%     V    =   list of  points
%  Outputs:
%     v   =  combined point
%    nV   =  list of the rest of the points
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
 
%  Find the global numerical bounds:
 
global KAPPA;global DELTA;global KAPPA;global ERRFACTOR;
 
%  Establish number of points and intialise Boolean array:
 
[nv,c]=size(V);iind=zeros(nv,1)>1;
 
%  Find points DELTA-near to `V(1,:)' :
 
for i=1:nv,
   w=V(i,:)-V(1,:);
   iind(i)=( norm(w) < DELTA );
end;
 
%  List DELTA-near points in `W':
 
W=V(iind,:);[n,c]=size(W);
 
%  Set the new first point:
 
if n>1, v=mean(W); else v=W;end;
 
%  List of the rest of the points:
 
nV=V(~iind,:);
return;
