function mu=fvfitacc(P);
%  FVFITACC: extract the maximum fitting error of vertices and facets
%  Inputs:
%     P[[0 eps; 1 1; -1 1;-1 -1; 1 -1]] = polytope
%  Outputs:
%     mu[eps] = maximum fitting error
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  Find global numerical bounds:
 
global DELTA;global KAPPA;global ERRFACTOR;
 
%  Activate interface if any of the bounds is undefined:
 
if (isempty(DELTA) | isempty(KAPPA)), setdelta;P=[];end;
 
%  Exract worst-case errors:
 
if size(P,2)==2, mu=P(1,2);else mu=P(1,3);end;
 
%  If error is two large then give warning:
 
if mu>DELTA, warndel;end;
return;
