function  Boole=intest(V,P);
%  INTEST: test whether a set of points is in polytope
%  Inputs:
%     V[0]    = array of points
%     P[[0 eps;1 1;-1 1;-1 -1;1 -1]]  = polytope
%  Outputs:
%    Boole[1]   = Boolean value
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
%  Find global numerical bounds:
 
global DELTA;global KAPPA;global ERRFACTOR;
 
%  Activate interface if any of the bounds is undefined:
 
if (isempty(DELTA) | isempty(KAPPA)), setdelta;P=[];end;
 
%   Extract defining half-space inequalities of the polytope:
 
F=faces(P);
 
%  Test whether the points in `V' all satisfy the half space inequalities:
 
Boole= (max(F*[V -ones(size(V,1),1)]') <= DELTA)';
return;
