function f=maxface(n,d);
%  MAXFACE: compute the vector of maximum no. faces for given number of vertices
%   n[3] = number of vertices
%    d[2]   = dimension
%  Outputs:
%     f[3]  = vector of max. no. faces
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  Compute the maximum possible number of facets
%  if number of vertices is given:
 
f=zeros(d-1,1);
if (rem(d,2)==0), even=1;l=d/2; else even=0;l=(d-1)/2;end;
for j=1:d-1,
  if (even),
    for i=1:l,
      b1=1;
      for k=n-2*i+1:n-i,b1=b1*k;end;
      for k=1:i,b1=b1/k;end;
      b2=1;
      for k=2*i-j:i,b2=b2*k;end;
      for k=1:(j+1-i),b2=b2/k;end;
      f(j)=f(j)+n*b1*b2/(n-i);
    end;
  else
    for i=0:l,
      b1=1;
      for k=n-2*i:n-i,b1=b1*k;end;
      for k=1:i+1,b1=b1/k;end;
      b2=1;
      for k=2*i-j+1:i+1,b1=b1*k;end;
      for k=1:j+1-i,b2=b2/k;end;
      f(j)=f(j)+(j+2)*b1*b2/(n-i);
    end;
  end;
end;
 
return;
 
 
 
