function EP=projell(E,SM);
%  PROJELL: project ellipsoid onto subspace
%   Inputs:
%      E[[1 0;1 0]  = ellipsoid
%       SM  = spanning vectors of subspace
%   Outputs:
%        EP = projected ellipsoid
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
%  Find dimensions:
 
[er,ec]=size(E);
[smr,d_new]=size(SM);
 
%   Produce transformation matrix:
 
nrm=diag(sqrt(diag((SM'*SM))));
SM=SM*pinv(nrm);
T=pinv(SM*SM')*SM;
 
%   Transform the ellipsoid:
 
   M=E(2:er,1:ec-1);
   centre=E(2:er,ec);
   M_new=T'*M*T;   % new covariance matrix
   centre_new=T'*centre;
   EP=zeros(d_new+1,d_new+1);
   
%   Build up the new ellipsoid representation:
   
   EP(1,1)=1;
   EP(2:d_new+1,1:d_new)=M_new;
   EP(2:d_new+1,d_new+1)=centre_new;
   return;
