%  This is a script M-file not a function.
%  Declare DELTA and KAPPA as global variables:
 
global DELTA;global KAPPA;global ERRFACTOR;global MAXSIZE;
 
%  Presenting user interface to type in KAPPA required:
 
disp('  ');
disp('Half-edge-size of a hypercube centred to the  ');
disp('origin which will include all polytopes');
KAPPA=input('to be used [default of KAPPA is 100]: KAPPA='); 
if isempty(KAPPA), KAPPA=100;end;
 
%  Calculating and print  the value of DELTA :
 
disp('The facet-vertex fitting tolerance DELTA is set to the ');
disp('following value for all computations in GBT routines:');
 
DELTA=KAPPA*1e-13
 
%  Presenting user interface to type in ERRFACTOR required:
 
disp('Define ERRFACTOR for internal/external polytope computations,');
ERRFACTOR=input('(the default of ERRFACTOR is 100) ERRFACTOR='); 
if isempty(ERRFACTOR), ERRFACTOR=100;end;
 
disp('The error-factor ERRFACTOR for inner and outer bounding is set to:');
 
ERRFACTOR 
 
disp('Each of ERRFACTOR, DELTA and KAPPA are global variables and ');
disp('can be redefined in the Command Window of MATLAB.');
 
 
disp('Define the maximum arrray size you allow to be used by MATLAB:');
MAXSIZE=input('(the default of MAXSIZE is 8*10^6 Bytes) MAXSIZE='); 
if isempty(MAXSIZE), MAXSIZE=8*1e+6;end;
 
disp('The maximum array size has been set to:');
 
MAXSIZE
 
disp('Each of MAXSIZE, ERRFACTOR, DELTA and KAPPA are global variables and ');
disp('can be redefined in the Command Window of MATLAB. MAXSIZE is needed ');
disp('as handling of memory overflow is not always safe by by MATLAB.');
disp(' ');
disp('If you wish to monitor computational progress then define the global ');
disp('variable COMPLX. After the run, or in case of error, you can look up');
disp('the file "complex.txt" produced in your current directory. Note that');
disp(' "complex.txt" is always added to new lines and you have to erase/restart it');
disp('before it becomes too large');
