function [S,S1]=slicegbt(h,P);
%   SLICEGBT: compute the intersection of a polytope and a hyperplane
%    Inputs:
%     h    =   linear equation ax'=b in form h=[a b]
%     P    =   polytope
%    Outputs:
%     S    = slice in d-dimensional representation
%     S1   = slice in lowest dimensional representation
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
global DELTA; global KAPPA;global ERRFACTOR;
d=dim(P);
 
 
if norm(h(1:d))>DELTA*abs(h(d+1)),
    h=h/norm(h(1:d));
 else 
    error(' slicing ill defined into SLICEGBT ');
end;
 
 
P1=update(h,P)
P2=update(-h,P);
 
 
if dim(P1)==d & dim(P2)==d,
    [F1,nf]=faces(P1);
    v=F1-ones(nf,1)*h;w=ones(nf,1);
    for i=1:nf, 
        w(i)=v(i,:)*v(i,:)';
    end;
    [mi,find]=min(w)
    [S1,S]=facet(P1,find)
    return;
end;
 
 
if dim(P1)<=d | dim(P2)==d,
    S=P1;
    S1=mindim(P1);
end;
 
if dim(P2)==d | dim(P1)<=d,
    S=P2;
    S1=mindim(P2);
end;
 
if dim(P1)<d & dim(P2)<d, 
   S=fconvh([h;-h+[0 0 0 DELTA]],P);
   S1=mindim(S);
end;
return;
 
   
    
