function U=uni(U1,U2);
%  UNI: compute the union of two point sets
%  Inputs:
%     U1[1]  =  matrix of row vectors
%     U2[1]  =  matrix of row vectors
%   Outputs:
%     U[1]  =  union of vector sets
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  The global precision bounds are set:
 
global DELTA;global KAPPA;global ERRFACTOR;
 
%  Activate user interface SETDELTA if not defined:
 
if (isempty(DELTA) | isempty(KAPPA)), H=[];setdelta;end;
 
%  Deal with special case:
 
if isempty(U1), U=U2;return;end;
 
%  Find dimensions and diagnostics:
 
[n1,d1]=size(U1);[n2,d2]=size(U2);
if d1~=d2, error('Size of vectors must be the same in UNI.M');end;
 
%  Compare each vector in U1 with all vectors in U2:
 
U=U2;
for i=1:n1,
  if min(max(abs(U2-ones(n2,1)*U1(i,:))')) > DELTA, 
    U=[U;U1(i,:)];
  end;
end;
return;
 
