function [V,nv]=vertices(P);
%  VERTICES: produce the list of vertices of a polytope
%  Inputs:
%    P[[1 eps;1 0]] = polytope
%  Outputs:
%    V[0]   = array of vertices
%     nv[1] = number of vertices
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
%  The global precision bounds are set:
 
global DELTA;global KAPPA;global ERRFACTOR;
 
%  Activate user interface SETDELTA if not defined:
 
if (isempty(DELTA) | isempty(KAPPA)), H=[];setdelta;end;
 
%  Do diagnostics:
 
[np,d]=size(P);
if (d<2),
   disp('Warning! Dimension of polytope must be at least one in "vertices.m".');
   V=[];nv=0;return;
end;
 
%  Extract vertices:
 
if d<3,  
    V=P(1+P(1,1)+3:np,1:(d-1)); 
else
    V=P(1+P(1,1)+P(1,2)+1:np,1:(d-1));
end;
[nv,d]=size(V);
 
%  Give warning if KAPPA-hyperplane is exceeded.
 
if max(max(abs(V)))>(KAPPA+DELTA)*(1+2*d*eps), warnkap;end;
return;
 
