function [VV,VF,nv,nh]=vvf(H);
%  VVF: produce a vertex-vertex and vertex-facet adjacency tables (version no. 1)
%  Inputs:
%      H  = polytope
%  Outputs:
%     VV  = vertex-vertex adjacency table
%     VF  = vertex-facet adjacency table
%     nv  = number of vertices
%     nh  = number of facets
% 
% Copyright (c) SysBrain, S M Veres 19-05-2001 
 
 
global DELTA;global KAPPA;global ERRFACTOR;
 
if (isempty(DELTA) | isempty(KAPPA)), setdelta;break;end;
[nH,d]=size(H);if d>2,d=d-1;end;
 
[F,nh,ne]=faces(H);
[V,nv]=vertices(H);
ne=H(1,1);
 
 
I=F*[V -ones(nv,1)]';
nh=nh+2*ne;
Ind=abs(I)<DELTA*ones(nh,nv);
 
 
 
hmax=max(sum(Ind));indx=(1:nh)';
VF=zeros(nv,hmax);
for i=1:nv, 
   vf=indx(Ind(:,i));noh=size(vf,1);
   VF(i,1:noh)=vf';
end;
 
 
Indv = (Ind'*Ind > (d-ne-1.1)*ones(nv,nv)) & ~eye(nv);
sIv=sum(Indv);
nvv=max(sIv);
indxv=(1:nv)';
VV=zeros(nv,nvv);
for i=1:nv,
   VV(i,1:sIv(i))=indxv(Indv(:,i))'; % constructing the vertex-hyperplane adjacency list
end;
 
return
   
 
